/*
 * MainClass.cs
 * 
 * Alvaro Cortes
 * Noviembre 2006.
 * 
 * 
 * Clase principal del proyecto.
 */

 using System;
 using System.Windows.Forms;
 
 namespace FormulacionMagistral{
 	
 
/// <summary>
/// Clase principal del proyecto
/// Punto de arranque para todo el programa
///</summary>
 public class MainClass{
	
	
	
	#region Metodo de incio de la aplicacin
	/// <summary>Metodo de inicio</summary>
	public static void Main(string[] args){
		int currentid;
		SplashForm spl = new SplashForm(2); // Formulario de splash
		currentid = getNewAppID(); // ID de la instancia actual
		LoginForm lg = new LoginForm(currentid); // Nuevo formulario de login de la instancia
		bool login_ok;
		try{
		// Mostrar el splash
		spl.ShowDialog();
		spl.Dispose();
		}catch(Exception ex){
			FM_Errores.MostrarError("Inicio aplicacion","No se puede mostrar el dialogo splash",ex);
		}
		// Comprobar el acceso a base de datos
	try{
		if ( !CheckDBConfig() )
		{
			MessageBox.Show("No se puede acceder a la base de datos. Asegurese de que la configuracin es correcta o de que no hay problemas en el inicio del servicio de la base de datos","Error grave");
			Application.Exit();
		}else{
		// Mostrar el login
		lg.ShowDialog();
		login_ok = lg.login_ok;
		lg.Dispose();
		
		// Correr el formulario principal
		if( login_ok){
		MainForm m1 = new MainForm(currentid);
		m1.ShowDialog();
		}
		}
	}catch(Exception ex){
		FM_Errores.MostrarError("Inicio Aplicacion","Ha ocurrido un error grave y la aplicacion no puede iniciar normalmente",ex);
	}
 	}
	#endregion
	
	#region Mtodos de comprobacin e inicio
	/// <summary>
	/// Genera un nuevo numero aleatorio para identificar la instancia 
	/// de la aplicacion
	/// </summary>
	/// <returns>Devuelve un numero entero</returns>
	public static int getNewAppID(){
		Random rnd = new Random(unchecked((int) DateTime.Now.Ticks));
		return rnd.Next(10000);
	}
	
	/// <summary>
	/// Comprueba la conexin con la base de datos para que 
	/// la aplicacin no inicie secciones dependiente de la base
	/// de datos
	/// </summary>
	/// <returns>Devuelve verdadero si se tiene conexin</returns>
	public static bool CheckDBConfig(){
		
		Formulacion.PreferenciasDB DBPrefs = new Formulacion.PreferenciasDB();
		Formulacion.TestDBConnection dbtest = new Formulacion.TestDBConnection();
		string[] prf;
		string connstring;
		DBPrefs.AsignarNmbFichero("PrefDataBase.xml");
		
			if ( DBPrefs.LeerFichero() )
			{
				prf = DBPrefs.CargarPreferenciasDB();
				connstring = "host="+prf[0]+";port="+prf[1]+";user id="+prf[2]+";password="+prf[3]+";database=formulacion";
				DBPrefs.CerrarEntrada();
				
				dbtest.setConnectionString(connstring);
				return dbtest.testConnection();
			}

			return false;
	
	}
 	#endregion
 }
 }
