/*
 *
 *	FInternals.cs
 *
 *	Clase con codigo interno de Farmakito.
 *
 *	Farmakito: Asistente tipo Clip del office.
 *
 */


using System;
using System.Collections;

namespace Farmakito{

/// <summary>
/// Clase relacionada con el procesamiento de las peticiones a Farmakito.
/// </summary>
class Oraciones{

	public string[] palabras;
	private string oracion;
	char[] sep = {'.',',',' ','\t','\n','\0'};
	// Preposiciones
	string[] preps = {"a","ante","bajo","cabe","con","contra","de","desde","en","entre","hacia","hasta","para","por","si","so","sobre","segun","segn","tras"};
	// Resto de cosas
	string[] art = {"un","uno","una","unos","unas","el","la","lo","las","los","eso","esto","aquello","esa","ese","esta","este","aquellos","aquellas","esas","estas","estos","esos","como","se","cmo","qu","que"};
	/// <summary>
	/// Proporciona el valor de la oracion de peticion a Farmakito.
	/// </summary>
	/// <param name="strOracion">Peticion a realizar</param>
	public void AsignarOracion(string strOracion){
		oracion = strOracion;
	}

	/// <summary>
	/// Divide la oracion en palabras
	/// </summary>
	public void DividirPalabras(){
		string[] tmpPalabras;
		ArrayList tmpPalabrasFitr = new ArrayList();
		int i,i2;
		bool prepFlag = false;
		tmpPalabras = oracion.Split(sep);

		
		for(i = 0; i< tmpPalabras.Length; ++i)
		{
			prepFlag = false;

			// Buscando preposiciones para eliminarlas
			for(i2 = 0; i2< preps.Length; ++i2)
			{
				if( System.String.Compare(tmpPalabras[i],
				preps[i2],true) == 0)
				{
					prepFlag = true;
					break;
				}
			}	

			// Haciendo lo propio con los articulos y determinantes y resto
			for( i2 = 0; i2 < art.Length; i2++)
			{
				if( System.String.Compare(tmpPalabras[i],
				art[i2],true) == 0)
				{
					prepFlag = true;
					break;
				}
			}

			if( !prepFlag )
			tmpPalabrasFitr.Add(tmpPalabras[i]);
		}

		palabras = (string[])tmpPalabrasFitr.ToArray(typeof(string));
	
	} // Fin metodo DividirPalabras.


} // Fin de la clase Oraciones.


} // Fin namespace.
