/*
 * 
 * FormulasForm
 * 
 * 
 * (C) Alvaro Cortes. 2007. alvarocortesc@gmail.com
 * 
 * 
 * Gestion de las formulas. Cargar/Guardar formulas. No tasacion
 * 
 */

using System;
using System.Drawing;
using System.Windows.Forms;

using System.Drawing.Printing;
using MySql.Data.MySqlClient;
using System.Data;


namespace FormulacionMagistral
{
	/// <summary>
	/// Description of FormulasForm.
	/// </summary>
	public class FormulasForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button btnBorrar10;
		private System.Windows.Forms.Button btnBorrar11;
		private System.Windows.Forms.Label lblUnidades;
		private System.Windows.Forms.Label lblNombres;
		private System.Windows.Forms.Label lblCantidad;
		private System.Windows.Forms.TextBox txtNombre11;
		private System.Windows.Forms.TextBox txtNombre10;
		private System.Windows.Forms.Label lblNombre;
		private System.Windows.Forms.TextBox txtFormulaID;
		private System.Windows.Forms.Button btnGuardar;
		private System.Windows.Forms.Label lblFormulaID;
		private System.Windows.Forms.Label lblPos;
		private System.Windows.Forms.TextBox txtNombre4;
		private System.Windows.Forms.Label lblProspecto;
		private System.Windows.Forms.TextBox txtNombre1;
		private System.Windows.Forms.TextBox txtNombre2;
		private System.Windows.Forms.TextBox txtNombre8;
		private System.Windows.Forms.Label lblComponenteID;
		private System.Windows.Forms.Button btnImprimir;
		private System.Windows.Forms.TextBox txtProspecto;
		private System.Windows.Forms.TextBox Unidades1;
		private System.Windows.Forms.TextBox Unidades2;
		private System.Windows.Forms.TextBox Unidades3;
		private System.Windows.Forms.TextBox Unidades4;
		private System.Windows.Forms.TextBox Unidades5;
		private System.Windows.Forms.TextBox Unidades6;
		private System.Windows.Forms.TextBox txtCantidad10;
		private System.Windows.Forms.TextBox txtCantidad11;
		private System.Windows.Forms.TextBox Unidades9;
		private System.Windows.Forms.Button btnSelect10;
		private System.Windows.Forms.Button btnSelect11;
		private System.Windows.Forms.Label lblObservaciones;
		private System.Windows.Forms.TextBox txtCantidad9;
		private System.Windows.Forms.TextBox txtCantidad8;
		private System.Windows.Forms.Button btnAbrir;
		private System.Windows.Forms.TextBox txtCantidad5;
		private System.Windows.Forms.TextBox txtCantidad4;
		private System.Windows.Forms.Button btnBorrar2;
		private System.Windows.Forms.Button btnBorrar1;
		private System.Windows.Forms.TextBox txtCantidad1;
		private System.Windows.Forms.Button btnBorrar7;
		private System.Windows.Forms.TextBox txtCantidad3;
		private System.Windows.Forms.Button btnBorrar5;
		private System.Windows.Forms.Button btnBorrar4;
		private System.Windows.Forms.Button btnNuevo;
		private System.Windows.Forms.Button btnBorrar9;
		private System.Windows.Forms.Button btnBorrar8;
		private System.Windows.Forms.Button btnPrev;
		private System.Windows.Forms.TextBox txtNombre;
		private System.Windows.Forms.Button btnSelect5;
		private System.Windows.Forms.Button btnSelect4;
		private System.Windows.Forms.Button btnSelect7;
		private System.Windows.Forms.Button btnSelect6;
		private System.Windows.Forms.Button btnSelect1;
		private System.Windows.Forms.Button btnSelect3;
		private System.Windows.Forms.Button btnSelect2;
		private System.Windows.Forms.TextBox txtNombre5;
		private System.Windows.Forms.TextBox txtNombre6;
		private System.Windows.Forms.TextBox txtNombre7;
		private System.Windows.Forms.Button btnSelect9;
		private System.Windows.Forms.Button btnSelect8;
		private System.Windows.Forms.TextBox txtNombre3;
		private System.Windows.Forms.Button btnBorrar;
		private System.Windows.Forms.Button btnBorrar3;
		private System.Windows.Forms.TextBox txtNombre9;
		private System.Windows.Forms.TextBox Unidades7;
		private System.Windows.Forms.TextBox Unidades8;
		private System.Windows.Forms.Button btnBorrar6;
		private System.Windows.Forms.Button btnFirst;
		private System.Windows.Forms.TextBox txtComponenteID8;
		private System.Windows.Forms.Button btnNext;
		private System.Windows.Forms.TextBox txtObservaciones;
		private System.Windows.Forms.TextBox txtComponenteID2;
		private System.Windows.Forms.TextBox txtComponenteID3;
		private System.Windows.Forms.TextBox txtComponenteID1;
		private System.Windows.Forms.TextBox txtComponenteID6;
		private System.Windows.Forms.TextBox txtComponenteID7;
		private System.Windows.Forms.TextBox txtComponenteID4;
		private System.Windows.Forms.TextBox txtComponenteID5;
		private System.Windows.Forms.TextBox txtComponenteID9;
		private System.Windows.Forms.TextBox txtComponenteID11;
		private System.Windows.Forms.TextBox txtComponenteID10;
		private System.Windows.Forms.TextBox Unidades11;
		private System.Windows.Forms.TextBox Unidades10;
		private System.Windows.Forms.GroupBox grpComponentes;
		private System.Windows.Forms.TextBox txtCantidad7;
		private System.Windows.Forms.TextBox txtCantidad6;
		private System.Windows.Forms.TextBox txtCantidad2;
		private System.Windows.Forms.Button btnLast;
		
		private MySqlConnection conn;
		private MySqlDataAdapter adap;  
		private System.Data.DataSet ds;
		private System.Data.DataSet dsComps; // Componentes de la formula.
		private MySqlDataAdapter adapComps;  // componenetes de la formula
		private MySqlParameter parm;
		
	
		// Algunas variables para emular el CurrencyManager defectuoso de Mono
		private int RecCount;
		private int RecPosition;
				
		// Para cargar preferencias de la BD
		private Formulacion.PreferenciasDB DBPrefs;
		
		// Informacion para conexion BD
		private string dbhost;
		private string dbport;
		private string dbuser;
		private string dbpasoteword;
		
		// Nivel de acceso
		private int currentlevel;
		private Alertas AlertaLocal; // Alertas

		/// <summary>
		/// Constructor
		/// </summary>
		/// <param name="level">Nivel de acceso actual</param>
		public FormulasForm(int level)
		{
			//
			// The InitializeComponent() call is required for Windows Forms designer support.
			//
			InitializeComponent();
			
			
			this.currentlevel = level;
			
			DBPrefs = new Formulacion.PreferenciasDB();
			DBPrefs.AsignarNmbFichero("PrefDataBase.xml");
			
			//this.RecPosition = registro;
			AlertaLocal = new Alertas();
			
		}
		
		/// <summary>
		/// Obtiene el id del registro actual
		/// </summary>
		/// <returns>Devuelve un entero del ID del registro</returns>
		public int getcurrentid(){
			int n;
			try{
				n = Convert.ToInt32( this.txtFormulaID.Text);
				return n;
			}catch(Exception ex){
				FM_Errores.MostrarError("GetCurrentID","No se puede obtener el ID actual",ex);
				return -1;
			}
		}

		/// <summary>
		/// Carga la configuracin de la base de datos en la vars
		/// de la clase
		/// </summary>
		void CargarConfiguracionDatabase(){
			string[] prf;
			if ( this.DBPrefs.LeerFichero() )
			{
				prf = this.DBPrefs.CargarPreferenciasDB();
				
				for( int i = 0; i < prf.Length; ++i)
				{
					switch(i){
						case 0: this.dbhost = prf[0]; break;
						case 1: this.dbport = prf[1]; break;
						case 3: this.dbuser = prf[2]; break;
						case 4: this.dbpasoteword = prf[3]; break;
					
					}
				}
				this.DBPrefs.CerrarEntrada();
			}
		}
		
		
		private bool Conectar(){
			try{
		 	conn = new MySqlConnection("host="+this.dbhost+";port=" + this.dbport + ";user id="+this.dbuser+";password="+this.dbpasoteword+ ";database=formulacion");

		 	adap = new MySqlDataAdapter();
			ds = new System.Data.DataSet();
			
			adapComps=new MySqlDataAdapter();
			dsComps = new System.Data.DataSet();
			
			 	adap.SelectCommand = new MySqlCommand("SELECT * FROM formulas;",conn);
			adap.Fill(ds,"Formulas");
		 	
		 	return true;
			}catch(MySqlException ex){
				FM_Errores.MostrarError("FormulasForm","Error relacionado con base de datos",ex);
				return false;
			}catch(Exception e){
				FM_Errores.MostrarError("FormulasForm","Error general. No se puede cargar la informacion de formulas",e);
				return false;
			}
		 	
		}

		private void CargarComandoUpdate(){
			adap.UpdateCommand = new MySqlCommand("Update formulas Set FormulaID=?FormulaID, Nombre = ?Nombre, Prospecto = ?Prospecto, Observaciones=?Observaciones WHERE FormulaID = ?FormulaIDA ",conn);
			
			parm = adap.UpdateCommand.Parameters.Add("?FormulaIDA", MySqlDbType.Int32);
			parm.SourceColumn = "FormulaID";
			parm.SourceVersion = DataRowVersion.Original;
							
			parm = adap.UpdateCommand.Parameters.Add("?FormulaID", MySqlDbType.Int32);
			parm.SourceColumn = "FormulaID";
			parm.SourceVersion = DataRowVersion.Current;
			
			parm = adap.UpdateCommand.Parameters.Add("?Nombre", MySqlDbType.VarChar, 120 );
			parm.SourceColumn = "Nombre";
			parm.SourceVersion = DataRowVersion.Current;

			parm = adap.UpdateCommand.Parameters.Add("?Prospecto", MySqlDbType.VarChar, 255);
			parm.SourceColumn = "Prospecto";
			parm.SourceVersion = DataRowVersion.Current;

			parm = adap.UpdateCommand.Parameters.Add("?Observaciones", MySqlDbType.VarChar, 250);
			parm.SourceColumn = "Observaciones";
			parm.SourceVersion = DataRowVersion.Current;
			
			adapComps.UpdateCommand = new MySqlCommand("Update componentes_formulas Set MateriaID=?MateriaID, FormulaID = ?FormulaID, Cantidad = ?Cantidad WHERE FormulaID = ?FormulaIDA AND MateriaID=?MateriaIDA",conn);

			parm = adapComps.UpdateCommand.Parameters.Add("?MateriaID", MySqlDbType.Int32);
			parm.SourceColumn = "MateriaID";
			parm.SourceVersion = DataRowVersion.Current;

			parm = adapComps.UpdateCommand.Parameters.Add("?MateriaIDA", MySqlDbType.Int32);
			parm.SourceColumn = "MateriaID";
			parm.SourceVersion = DataRowVersion.Original;
			
			parm = adapComps.UpdateCommand.Parameters.Add("?FormulaID", MySqlDbType.Int32);
			parm.SourceColumn = "FormulaID";
			parm.SourceVersion = DataRowVersion.Current;

			parm = adapComps.UpdateCommand.Parameters.Add("?FormulaIDA", MySqlDbType.Int32);
			parm.SourceColumn = "FormulaID";
			parm.SourceVersion = DataRowVersion.Original;
			
			parm = adapComps.UpdateCommand.Parameters.Add("?Cantidad", MySqlDbType.Float);
			parm.SourceColumn = "Cantidad";
			parm.SourceVersion = DataRowVersion.Current;
			
			

		}
		
		private void CargarComandoDelete(){
			adap.DeleteCommand = new MySqlCommand("DELETE FROM formulas WHERE FormulaID = ?FormulaID",conn);
			
			parm = adap.DeleteCommand.Parameters.Add("?FormulaID", MySqlDbType.Int32);
			parm.SourceColumn = "FormulaID";
			parm.SourceVersion = DataRowVersion.Original;

			adapComps.DeleteCommand = new MySqlCommand("DELETE FROM componentes_formulas WHERE FormulaID = ?FormulaID AND MateriaID=?MateriaID",conn);
			
			parm = adapComps.DeleteCommand.Parameters.Add("?FormulaID", MySqlDbType.Int32);
			parm.SourceColumn = "FormulaID";
			parm.SourceVersion = DataRowVersion.Original;

			parm = adapComps.DeleteCommand.Parameters.Add("?MateriaID", MySqlDbType.Int32);
			parm.SourceColumn = "MateriaID";
			parm.SourceVersion = DataRowVersion.Original;
			
		}
		
		private void CargarComandoInsert(){
			adap.InsertCommand = new MySqlCommand("Insert into formulas(FormulaID, Nombre, Prospecto, Observaciones) VALUES (?FormulaID, ?Nombre, ?Prospecto, ?Observaciones)",conn);
			
			parm = adap.InsertCommand.Parameters.Add("?FormulaID", MySqlDbType.Int32);
			parm.SourceColumn = "FormulaID";
			parm.SourceVersion = DataRowVersion.Current;
			
			parm = adap.InsertCommand.Parameters.Add("?Nombre", MySqlDbType.VarChar, 120 );
			parm.SourceColumn = "Nombre";
			parm.SourceVersion = DataRowVersion.Current;

			parm = adap.InsertCommand.Parameters.Add("?Prospecto", MySqlDbType.VarChar, 255);
			parm.SourceColumn = "Prospecto";
			parm.SourceVersion = DataRowVersion.Current;

			parm = adap.InsertCommand.Parameters.Add("?Observaciones", MySqlDbType.VarChar, 250);
			parm.SourceColumn = "Observaciones";
			parm.SourceVersion = DataRowVersion.Current;

			
			adapComps.InsertCommand = new MySqlCommand("INSERT INTO componentes_formulas (MateriaID, FormulaID, Cantidad) VALUES (?MateriaID, ?FormulaID, ?Cantidad)",conn);

			parm = adapComps.InsertCommand.Parameters.Add("?MateriaID", MySqlDbType.Int32);
			parm.SourceColumn = "MateriaID";
			parm.SourceVersion = DataRowVersion.Current;

			
			parm = adapComps.InsertCommand.Parameters.Add("?FormulaID", MySqlDbType.Int32);
			parm.SourceColumn = "FormulaID";
			parm.SourceVersion = DataRowVersion.Current;

			
			parm = adapComps.InsertCommand.Parameters.Add("?Cantidad", MySqlDbType.Float);
			parm.SourceColumn = "Cantidad";
			parm.SourceVersion = DataRowVersion.Current;
			
			
		}
		
		
		
		#region Windows Forms Designer generated code
		/// <summary>
		/// This method is required for Windows Forms designer support.
		/// Do not change the method contents inside the source code editor. The Forms designer might
		/// not be able to load this method if it was changed manually.
		/// </summary>
		private void InitializeComponent() {
			this.btnLast = new System.Windows.Forms.Button();
			this.txtCantidad2 = new System.Windows.Forms.TextBox();
			this.txtCantidad6 = new System.Windows.Forms.TextBox();
			this.txtCantidad7 = new System.Windows.Forms.TextBox();
			this.grpComponentes = new System.Windows.Forms.GroupBox();
			this.Unidades10 = new System.Windows.Forms.TextBox();
			this.Unidades11 = new System.Windows.Forms.TextBox();
			this.txtComponenteID10 = new System.Windows.Forms.TextBox();
			this.txtComponenteID11 = new System.Windows.Forms.TextBox();
			this.txtComponenteID9 = new System.Windows.Forms.TextBox();
			this.txtComponenteID5 = new System.Windows.Forms.TextBox();
			this.txtComponenteID4 = new System.Windows.Forms.TextBox();
			this.txtComponenteID7 = new System.Windows.Forms.TextBox();
			this.txtComponenteID6 = new System.Windows.Forms.TextBox();
			this.txtComponenteID1 = new System.Windows.Forms.TextBox();
			this.txtComponenteID3 = new System.Windows.Forms.TextBox();
			this.txtComponenteID2 = new System.Windows.Forms.TextBox();
			this.txtObservaciones = new System.Windows.Forms.TextBox();
			this.btnNext = new System.Windows.Forms.Button();
			this.txtComponenteID8 = new System.Windows.Forms.TextBox();
			this.btnFirst = new System.Windows.Forms.Button();
			this.btnBorrar6 = new System.Windows.Forms.Button();
			this.Unidades8 = new System.Windows.Forms.TextBox();
			this.Unidades7 = new System.Windows.Forms.TextBox();
			this.txtNombre9 = new System.Windows.Forms.TextBox();
			this.btnBorrar3 = new System.Windows.Forms.Button();
			this.btnBorrar = new System.Windows.Forms.Button();
			this.txtNombre3 = new System.Windows.Forms.TextBox();
			this.btnSelect8 = new System.Windows.Forms.Button();
			this.btnSelect9 = new System.Windows.Forms.Button();
			this.txtNombre7 = new System.Windows.Forms.TextBox();
			this.txtNombre6 = new System.Windows.Forms.TextBox();
			this.txtNombre5 = new System.Windows.Forms.TextBox();
			this.btnSelect2 = new System.Windows.Forms.Button();
			this.btnSelect3 = new System.Windows.Forms.Button();
			this.btnSelect1 = new System.Windows.Forms.Button();
			this.btnSelect6 = new System.Windows.Forms.Button();
			this.btnSelect7 = new System.Windows.Forms.Button();
			this.btnSelect4 = new System.Windows.Forms.Button();
			this.btnSelect5 = new System.Windows.Forms.Button();
			this.txtNombre = new System.Windows.Forms.TextBox();
			this.btnPrev = new System.Windows.Forms.Button();
			this.btnBorrar8 = new System.Windows.Forms.Button();
			this.btnBorrar9 = new System.Windows.Forms.Button();
			this.btnNuevo = new System.Windows.Forms.Button();
			this.btnBorrar4 = new System.Windows.Forms.Button();
			this.btnBorrar5 = new System.Windows.Forms.Button();
			this.txtCantidad3 = new System.Windows.Forms.TextBox();
			this.btnBorrar7 = new System.Windows.Forms.Button();
			this.txtCantidad1 = new System.Windows.Forms.TextBox();
			this.btnBorrar1 = new System.Windows.Forms.Button();
			this.btnBorrar2 = new System.Windows.Forms.Button();
			this.txtCantidad4 = new System.Windows.Forms.TextBox();
			this.txtCantidad5 = new System.Windows.Forms.TextBox();
			this.btnAbrir = new System.Windows.Forms.Button();
			this.txtCantidad8 = new System.Windows.Forms.TextBox();
			this.txtCantidad9 = new System.Windows.Forms.TextBox();
			this.lblObservaciones = new System.Windows.Forms.Label();
			this.btnSelect11 = new System.Windows.Forms.Button();
			this.btnSelect10 = new System.Windows.Forms.Button();
			this.Unidades9 = new System.Windows.Forms.TextBox();
			this.txtCantidad11 = new System.Windows.Forms.TextBox();
			this.txtCantidad10 = new System.Windows.Forms.TextBox();
			this.Unidades6 = new System.Windows.Forms.TextBox();
			this.Unidades5 = new System.Windows.Forms.TextBox();
			this.Unidades4 = new System.Windows.Forms.TextBox();
			this.Unidades3 = new System.Windows.Forms.TextBox();
			this.Unidades2 = new System.Windows.Forms.TextBox();
			this.Unidades1 = new System.Windows.Forms.TextBox();
			this.txtProspecto = new System.Windows.Forms.TextBox();
			this.btnImprimir = new System.Windows.Forms.Button();
			this.lblComponenteID = new System.Windows.Forms.Label();
			this.txtNombre8 = new System.Windows.Forms.TextBox();
			this.txtNombre2 = new System.Windows.Forms.TextBox();
			this.txtNombre1 = new System.Windows.Forms.TextBox();
			this.lblProspecto = new System.Windows.Forms.Label();
			this.txtNombre4 = new System.Windows.Forms.TextBox();
			this.lblPos = new System.Windows.Forms.Label();
			this.lblFormulaID = new System.Windows.Forms.Label();
			this.btnGuardar = new System.Windows.Forms.Button();
			this.txtFormulaID = new System.Windows.Forms.TextBox();
			this.lblNombre = new System.Windows.Forms.Label();
			this.txtNombre10 = new System.Windows.Forms.TextBox();
			this.txtNombre11 = new System.Windows.Forms.TextBox();
			this.lblCantidad = new System.Windows.Forms.Label();
			this.lblNombres = new System.Windows.Forms.Label();
			this.lblUnidades = new System.Windows.Forms.Label();
			this.btnBorrar11 = new System.Windows.Forms.Button();
			this.btnBorrar10 = new System.Windows.Forms.Button();
			this.grpComponentes.SuspendLayout();
			this.SuspendLayout();
			// 
			// btnLast
			// 
			this.btnLast.Location = new System.Drawing.Point(232, 232);
			this.btnLast.Name = "btnLast";
			this.btnLast.Size = new System.Drawing.Size(32, 24);
			this.btnLast.TabIndex = 16;
			this.btnLast.Text = "->|";
			this.btnLast.Click += new System.EventHandler(this.BtnLastClick);
			// 
			// txtCantidad2
			// 
			this.txtCantidad2.Location = new System.Drawing.Point(336, 80);
			this.txtCantidad2.Name = "txtCantidad2";
			this.txtCantidad2.Size = new System.Drawing.Size(80, 20);
			this.txtCantidad2.TabIndex = 26;
			this.txtCantidad2.Text = "";
			// 
			// txtCantidad6
			// 
			this.txtCantidad6.Location = new System.Drawing.Point(336, 176);
			this.txtCantidad6.Name = "txtCantidad6";
			this.txtCantidad6.Size = new System.Drawing.Size(80, 20);
			this.txtCantidad6.TabIndex = 30;
			this.txtCantidad6.Text = "";
			// 
			// txtCantidad7
			// 
			this.txtCantidad7.Location = new System.Drawing.Point(336, 200);
			this.txtCantidad7.Name = "txtCantidad7";
			this.txtCantidad7.Size = new System.Drawing.Size(80, 20);
			this.txtCantidad7.TabIndex = 31;
			this.txtCantidad7.Text = "";
			// 
			// grpComponentes
			// 
			this.grpComponentes.Controls.Add(this.btnSelect11);
			this.grpComponentes.Controls.Add(this.btnSelect10);
			this.grpComponentes.Controls.Add(this.btnSelect9);
			this.grpComponentes.Controls.Add(this.btnSelect8);
			this.grpComponentes.Controls.Add(this.btnSelect7);
			this.grpComponentes.Controls.Add(this.btnSelect6);
			this.grpComponentes.Controls.Add(this.btnSelect5);
			this.grpComponentes.Controls.Add(this.btnSelect4);
			this.grpComponentes.Controls.Add(this.btnSelect3);
			this.grpComponentes.Controls.Add(this.btnSelect2);
			this.grpComponentes.Controls.Add(this.btnBorrar11);
			this.grpComponentes.Controls.Add(this.btnBorrar10);
			this.grpComponentes.Controls.Add(this.btnBorrar9);
			this.grpComponentes.Controls.Add(this.btnBorrar8);
			this.grpComponentes.Controls.Add(this.btnBorrar7);
			this.grpComponentes.Controls.Add(this.btnBorrar6);
			this.grpComponentes.Controls.Add(this.btnBorrar5);
			this.grpComponentes.Controls.Add(this.btnBorrar4);
			this.grpComponentes.Controls.Add(this.btnBorrar3);
			this.grpComponentes.Controls.Add(this.btnBorrar2);
			this.grpComponentes.Controls.Add(this.btnSelect1);
			this.grpComponentes.Controls.Add(this.btnBorrar1);
			this.grpComponentes.Controls.Add(this.lblUnidades);
			this.grpComponentes.Controls.Add(this.Unidades11);
			this.grpComponentes.Controls.Add(this.Unidades10);
			this.grpComponentes.Controls.Add(this.Unidades9);
			this.grpComponentes.Controls.Add(this.Unidades8);
			this.grpComponentes.Controls.Add(this.Unidades7);
			this.grpComponentes.Controls.Add(this.Unidades6);
			this.grpComponentes.Controls.Add(this.Unidades5);
			this.grpComponentes.Controls.Add(this.Unidades4);
			this.grpComponentes.Controls.Add(this.Unidades3);
			this.grpComponentes.Controls.Add(this.Unidades2);
			this.grpComponentes.Controls.Add(this.Unidades1);
			this.grpComponentes.Controls.Add(this.txtCantidad11);
			this.grpComponentes.Controls.Add(this.txtCantidad10);
			this.grpComponentes.Controls.Add(this.txtCantidad9);
			this.grpComponentes.Controls.Add(this.txtCantidad8);
			this.grpComponentes.Controls.Add(this.txtCantidad7);
			this.grpComponentes.Controls.Add(this.txtCantidad6);
			this.grpComponentes.Controls.Add(this.txtCantidad5);
			this.grpComponentes.Controls.Add(this.txtCantidad4);
			this.grpComponentes.Controls.Add(this.txtCantidad3);
			this.grpComponentes.Controls.Add(this.txtCantidad2);
			this.grpComponentes.Controls.Add(this.txtCantidad1);
			this.grpComponentes.Controls.Add(this.lblCantidad);
			this.grpComponentes.Controls.Add(this.txtNombre11);
			this.grpComponentes.Controls.Add(this.txtNombre10);
			this.grpComponentes.Controls.Add(this.txtNombre9);
			this.grpComponentes.Controls.Add(this.txtNombre8);
			this.grpComponentes.Controls.Add(this.txtNombre7);
			this.grpComponentes.Controls.Add(this.txtNombre6);
			this.grpComponentes.Controls.Add(this.txtNombre5);
			this.grpComponentes.Controls.Add(this.txtNombre2);
			this.grpComponentes.Controls.Add(this.txtNombre3);
			this.grpComponentes.Controls.Add(this.txtNombre4);
			this.grpComponentes.Controls.Add(this.txtNombre1);
			this.grpComponentes.Controls.Add(this.lblNombres);
			this.grpComponentes.Controls.Add(this.lblComponenteID);
			this.grpComponentes.Controls.Add(this.txtComponenteID10);
			this.grpComponentes.Controls.Add(this.txtComponenteID9);
			this.grpComponentes.Controls.Add(this.txtComponenteID8);
			this.grpComponentes.Controls.Add(this.txtComponenteID7);
			this.grpComponentes.Controls.Add(this.txtComponenteID6);
			this.grpComponentes.Controls.Add(this.txtComponenteID5);
			this.grpComponentes.Controls.Add(this.txtComponenteID4);
			this.grpComponentes.Controls.Add(this.txtComponenteID3);
			this.grpComponentes.Controls.Add(this.txtComponenteID11);
			this.grpComponentes.Controls.Add(this.txtComponenteID2);
			this.grpComponentes.Controls.Add(this.txtComponenteID1);
			this.grpComponentes.Location = new System.Drawing.Point(8, 272);
			this.grpComponentes.Name = "grpComponentes";
			this.grpComponentes.Size = new System.Drawing.Size(584, 328);
			this.grpComponentes.TabIndex = 7;
			this.grpComponentes.TabStop = false;
			this.grpComponentes.Text = "Componentes";
			// 
			// Unidades10
			// 
			this.Unidades10.Enabled = false;
			this.Unidades10.Location = new System.Drawing.Point(448, 272);
			this.Unidades10.Name = "Unidades10";
			this.Unidades10.Size = new System.Drawing.Size(40, 20);
			this.Unidades10.TabIndex = 45;
			this.Unidades10.Text = "";
			this.Unidades10.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			// 
			// Unidades11
			// 
			this.Unidades11.Enabled = false;
			this.Unidades11.Location = new System.Drawing.Point(448, 296);
			this.Unidades11.Name = "Unidades11";
			this.Unidades11.Size = new System.Drawing.Size(40, 20);
			this.Unidades11.TabIndex = 46;
			this.Unidades11.Text = "";
			this.Unidades11.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			// 
			// txtComponenteID10
			// 
			this.txtComponenteID10.Enabled = false;
			this.txtComponenteID10.Location = new System.Drawing.Point(56, 272);
			this.txtComponenteID10.Name = "txtComponenteID10";
			this.txtComponenteID10.Size = new System.Drawing.Size(32, 20);
			this.txtComponenteID10.TabIndex = 10;
			this.txtComponenteID10.Text = "";
			this.txtComponenteID10.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			// 
			// txtComponenteID11
			// 
			this.txtComponenteID11.Enabled = false;
			this.txtComponenteID11.Location = new System.Drawing.Point(56, 296);
			this.txtComponenteID11.Name = "txtComponenteID11";
			this.txtComponenteID11.Size = new System.Drawing.Size(32, 20);
			this.txtComponenteID11.TabIndex = 2;
			this.txtComponenteID11.Text = "";
			this.txtComponenteID11.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			// 
			// txtComponenteID9
			// 
			this.txtComponenteID9.Enabled = false;
			this.txtComponenteID9.Location = new System.Drawing.Point(56, 248);
			this.txtComponenteID9.Name = "txtComponenteID9";
			this.txtComponenteID9.Size = new System.Drawing.Size(32, 20);
			this.txtComponenteID9.TabIndex = 9;
			this.txtComponenteID9.Text = "";
			this.txtComponenteID9.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			// 
			// txtComponenteID5
			// 
			this.txtComponenteID5.Enabled = false;
			this.txtComponenteID5.Location = new System.Drawing.Point(56, 152);
			this.txtComponenteID5.Name = "txtComponenteID5";
			this.txtComponenteID5.Size = new System.Drawing.Size(32, 20);
			this.txtComponenteID5.TabIndex = 5;
			this.txtComponenteID5.Text = "";
			this.txtComponenteID5.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			// 
			// txtComponenteID4
			// 
			this.txtComponenteID4.Enabled = false;
			this.txtComponenteID4.Location = new System.Drawing.Point(56, 128);
			this.txtComponenteID4.Name = "txtComponenteID4";
			this.txtComponenteID4.Size = new System.Drawing.Size(32, 20);
			this.txtComponenteID4.TabIndex = 4;
			this.txtComponenteID4.Text = "";
			this.txtComponenteID4.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			// 
			// txtComponenteID7
			// 
			this.txtComponenteID7.Enabled = false;
			this.txtComponenteID7.Location = new System.Drawing.Point(56, 200);
			this.txtComponenteID7.Name = "txtComponenteID7";
			this.txtComponenteID7.Size = new System.Drawing.Size(32, 20);
			this.txtComponenteID7.TabIndex = 7;
			this.txtComponenteID7.Text = "";
			this.txtComponenteID7.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			// 
			// txtComponenteID6
			// 
			this.txtComponenteID6.Enabled = false;
			this.txtComponenteID6.Location = new System.Drawing.Point(56, 176);
			this.txtComponenteID6.Name = "txtComponenteID6";
			this.txtComponenteID6.Size = new System.Drawing.Size(32, 20);
			this.txtComponenteID6.TabIndex = 6;
			this.txtComponenteID6.Text = "";
			this.txtComponenteID6.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			// 
			// txtComponenteID1
			// 
			this.txtComponenteID1.Enabled = false;
			this.txtComponenteID1.Location = new System.Drawing.Point(56, 56);
			this.txtComponenteID1.Name = "txtComponenteID1";
			this.txtComponenteID1.Size = new System.Drawing.Size(32, 20);
			this.txtComponenteID1.TabIndex = 0;
			this.txtComponenteID1.Text = "";
			this.txtComponenteID1.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			// 
			// txtComponenteID3
			// 
			this.txtComponenteID3.Enabled = false;
			this.txtComponenteID3.Location = new System.Drawing.Point(56, 104);
			this.txtComponenteID3.Name = "txtComponenteID3";
			this.txtComponenteID3.Size = new System.Drawing.Size(32, 20);
			this.txtComponenteID3.TabIndex = 3;
			this.txtComponenteID3.Text = "";
			this.txtComponenteID3.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			// 
			// txtComponenteID2
			// 
			this.txtComponenteID2.Enabled = false;
			this.txtComponenteID2.Location = new System.Drawing.Point(56, 80);
			this.txtComponenteID2.Name = "txtComponenteID2";
			this.txtComponenteID2.Size = new System.Drawing.Size(32, 20);
			this.txtComponenteID2.TabIndex = 1;
			this.txtComponenteID2.Text = "";
			this.txtComponenteID2.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			// 
			// txtObservaciones
			// 
			this.txtObservaciones.Location = new System.Drawing.Point(176, 112);
			this.txtObservaciones.Multiline = true;
			this.txtObservaciones.Name = "txtObservaciones";
			this.txtObservaciones.ScrollBars = System.Windows.Forms.ScrollBars.Both;
			this.txtObservaciones.Size = new System.Drawing.Size(552, 112);
			this.txtObservaciones.TabIndex = 18;
			this.txtObservaciones.Text = "";
			// 
			// btnNext
			// 
			this.btnNext.Location = new System.Drawing.Point(200, 232);
			this.btnNext.Name = "btnNext";
			this.btnNext.Size = new System.Drawing.Size(32, 24);
			this.btnNext.TabIndex = 15;
			this.btnNext.Text = "->";
			this.btnNext.Click += new System.EventHandler(this.BtnNextClick);
			// 
			// txtComponenteID8
			// 
			this.txtComponenteID8.Enabled = false;
			this.txtComponenteID8.Location = new System.Drawing.Point(56, 224);
			this.txtComponenteID8.Name = "txtComponenteID8";
			this.txtComponenteID8.Size = new System.Drawing.Size(32, 20);
			this.txtComponenteID8.TabIndex = 8;
			this.txtComponenteID8.Text = "";
			this.txtComponenteID8.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			// 
			// btnFirst
			// 
			this.btnFirst.Location = new System.Drawing.Point(24, 232);
			this.btnFirst.Name = "btnFirst";
			this.btnFirst.Size = new System.Drawing.Size(32, 24);
			this.btnFirst.TabIndex = 13;
			this.btnFirst.Text = "|<-";
			this.btnFirst.Click += new System.EventHandler(this.BtnFirstClick);
			// 
			// btnBorrar6
			// 
			this.btnBorrar6.Location = new System.Drawing.Point(504, 176);
			this.btnBorrar6.Name = "btnBorrar6";
			this.btnBorrar6.Size = new System.Drawing.Size(24, 24);
			this.btnBorrar6.TabIndex = 54;
			this.btnBorrar6.Text = "X";
			this.btnBorrar6.Click += new System.EventHandler(this.BtnBorrar6Click);
			// 
			// Unidades8
			// 
			this.Unidades8.Enabled = false;
			this.Unidades8.Location = new System.Drawing.Point(448, 224);
			this.Unidades8.Name = "Unidades8";
			this.Unidades8.Size = new System.Drawing.Size(40, 20);
			this.Unidades8.TabIndex = 43;
			this.Unidades8.Text = "";
			this.Unidades8.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			// 
			// Unidades7
			// 
			this.Unidades7.Enabled = false;
			this.Unidades7.Location = new System.Drawing.Point(448, 200);
			this.Unidades7.Name = "Unidades7";
			this.Unidades7.Size = new System.Drawing.Size(40, 20);
			this.Unidades7.TabIndex = 42;
			this.Unidades7.Text = "";
			this.Unidades7.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			// 
			// txtNombre9
			// 
			this.txtNombre9.Location = new System.Drawing.Point(136, 248);
			this.txtNombre9.Name = "txtNombre9";
			this.txtNombre9.Size = new System.Drawing.Size(176, 20);
			this.txtNombre9.TabIndex = 21;
			this.txtNombre9.Text = "";
			// 
			// btnBorrar3
			// 
			this.btnBorrar3.Location = new System.Drawing.Point(504, 104);
			this.btnBorrar3.Name = "btnBorrar3";
			this.btnBorrar3.Size = new System.Drawing.Size(24, 24);
			this.btnBorrar3.TabIndex = 51;
			this.btnBorrar3.Text = "X";
			this.btnBorrar3.Click += new System.EventHandler(this.BtnBorrar3Click);
			// 
			// btnBorrar
			// 
			this.btnBorrar.Location = new System.Drawing.Point(608, 336);
			this.btnBorrar.Name = "btnBorrar";
			this.btnBorrar.Size = new System.Drawing.Size(128, 24);
			this.btnBorrar.TabIndex = 10;
			this.btnBorrar.Text = "Borrar";
			this.btnBorrar.Click += new System.EventHandler(this.BtnBorrarClick);
			// 
			// txtNombre3
			// 
			this.txtNombre3.Location = new System.Drawing.Point(136, 104);
			this.txtNombre3.Name = "txtNombre3";
			this.txtNombre3.Size = new System.Drawing.Size(176, 20);
			this.txtNombre3.TabIndex = 15;
			this.txtNombre3.Text = "";
			// 
			// btnSelect8
			// 
			this.btnSelect8.Location = new System.Drawing.Point(528, 224);
			this.btnSelect8.Name = "btnSelect8";
			this.btnSelect8.Size = new System.Drawing.Size(32, 24);
			this.btnSelect8.TabIndex = 66;
			this.btnSelect8.Text = "->";
			this.btnSelect8.Click += new System.EventHandler(this.BtnSelect8Click);
			// 
			// btnSelect9
			// 
			this.btnSelect9.Location = new System.Drawing.Point(528, 248);
			this.btnSelect9.Name = "btnSelect9";
			this.btnSelect9.Size = new System.Drawing.Size(32, 24);
			this.btnSelect9.TabIndex = 67;
			this.btnSelect9.Text = "->";
			this.btnSelect9.Click += new System.EventHandler(this.BtnSelect9Click);
			// 
			// txtNombre7
			// 
			this.txtNombre7.Location = new System.Drawing.Point(136, 200);
			this.txtNombre7.Name = "txtNombre7";
			this.txtNombre7.Size = new System.Drawing.Size(176, 20);
			this.txtNombre7.TabIndex = 19;
			this.txtNombre7.Text = "";
			// 
			// txtNombre6
			// 
			this.txtNombre6.Location = new System.Drawing.Point(136, 176);
			this.txtNombre6.Name = "txtNombre6";
			this.txtNombre6.Size = new System.Drawing.Size(176, 20);
			this.txtNombre6.TabIndex = 18;
			this.txtNombre6.Text = "";
			// 
			// txtNombre5
			// 
			this.txtNombre5.Location = new System.Drawing.Point(136, 152);
			this.txtNombre5.Name = "txtNombre5";
			this.txtNombre5.Size = new System.Drawing.Size(176, 20);
			this.txtNombre5.TabIndex = 17;
			this.txtNombre5.Text = "";
			// 
			// btnSelect2
			// 
			this.btnSelect2.Location = new System.Drawing.Point(528, 80);
			this.btnSelect2.Name = "btnSelect2";
			this.btnSelect2.Size = new System.Drawing.Size(32, 24);
			this.btnSelect2.TabIndex = 60;
			this.btnSelect2.Text = "->";
			this.btnSelect2.Click += new System.EventHandler(this.BtnSelect2Click);
			// 
			// btnSelect3
			// 
			this.btnSelect3.Location = new System.Drawing.Point(528, 104);
			this.btnSelect3.Name = "btnSelect3";
			this.btnSelect3.Size = new System.Drawing.Size(32, 24);
			this.btnSelect3.TabIndex = 61;
			this.btnSelect3.Text = "->";
			this.btnSelect3.Click += new System.EventHandler(this.BtnSelect3Click);
			// 
			// btnSelect1
			// 
			this.btnSelect1.Location = new System.Drawing.Point(528, 56);
			this.btnSelect1.Name = "btnSelect1";
			this.btnSelect1.Size = new System.Drawing.Size(32, 24);
			this.btnSelect1.TabIndex = 49;
			this.btnSelect1.Text = "->";
			this.btnSelect1.Click += new System.EventHandler(this.BtnSelect1Click);
			// 
			// btnSelect6
			// 
			this.btnSelect6.Location = new System.Drawing.Point(528, 176);
			this.btnSelect6.Name = "btnSelect6";
			this.btnSelect6.Size = new System.Drawing.Size(32, 24);
			this.btnSelect6.TabIndex = 64;
			this.btnSelect6.Text = "->";
			this.btnSelect6.Click += new System.EventHandler(this.BtnSelect6Click);
			// 
			// btnSelect7
			// 
			this.btnSelect7.Location = new System.Drawing.Point(528, 200);
			this.btnSelect7.Name = "btnSelect7";
			this.btnSelect7.Size = new System.Drawing.Size(32, 24);
			this.btnSelect7.TabIndex = 65;
			this.btnSelect7.Text = "->";
			this.btnSelect7.Click += new System.EventHandler(this.BtnSelect7Click);
			// 
			// btnSelect4
			// 
			this.btnSelect4.Location = new System.Drawing.Point(528, 128);
			this.btnSelect4.Name = "btnSelect4";
			this.btnSelect4.Size = new System.Drawing.Size(32, 24);
			this.btnSelect4.TabIndex = 62;
			this.btnSelect4.Text = "->";
			this.btnSelect4.Click += new System.EventHandler(this.BtnSelect4Click);
			// 
			// btnSelect5
			// 
			this.btnSelect5.Location = new System.Drawing.Point(528, 152);
			this.btnSelect5.Name = "btnSelect5";
			this.btnSelect5.Size = new System.Drawing.Size(32, 24);
			this.btnSelect5.TabIndex = 63;
			this.btnSelect5.Text = "->";
			this.btnSelect5.Click += new System.EventHandler(this.BtnSelect5Click);
			// 
			// txtNombre
			// 
			this.txtNombre.Location = new System.Drawing.Point(176, 48);
			this.txtNombre.Name = "txtNombre";
			this.txtNombre.Size = new System.Drawing.Size(296, 20);
			this.txtNombre.TabIndex = 4;
			this.txtNombre.Text = "";
			// 
			// btnPrev
			// 
			this.btnPrev.Location = new System.Drawing.Point(56, 232);
			this.btnPrev.Name = "btnPrev";
			this.btnPrev.Size = new System.Drawing.Size(32, 24);
			this.btnPrev.TabIndex = 14;
			this.btnPrev.Text = "<-";
			this.btnPrev.Click += new System.EventHandler(this.BtnPrevClick);
			// 
			// btnBorrar8
			// 
			this.btnBorrar8.Location = new System.Drawing.Point(504, 224);
			this.btnBorrar8.Name = "btnBorrar8";
			this.btnBorrar8.Size = new System.Drawing.Size(24, 24);
			this.btnBorrar8.TabIndex = 56;
			this.btnBorrar8.Text = "X";
			this.btnBorrar8.Click += new System.EventHandler(this.BtnBorrar8Click);
			// 
			// btnBorrar9
			// 
			this.btnBorrar9.Location = new System.Drawing.Point(504, 248);
			this.btnBorrar9.Name = "btnBorrar9";
			this.btnBorrar9.Size = new System.Drawing.Size(24, 24);
			this.btnBorrar9.TabIndex = 57;
			this.btnBorrar9.Text = "X";
			this.btnBorrar9.Click += new System.EventHandler(this.BtnBorrar9Click);
			// 
			// btnNuevo
			// 
			this.btnNuevo.Location = new System.Drawing.Point(608, 272);
			this.btnNuevo.Name = "btnNuevo";
			this.btnNuevo.Size = new System.Drawing.Size(128, 24);
			this.btnNuevo.TabIndex = 8;
			this.btnNuevo.Text = "Nueva";
			this.btnNuevo.Click += new System.EventHandler(this.BtnNuevoClick);
			// 
			// btnBorrar4
			// 
			this.btnBorrar4.Location = new System.Drawing.Point(504, 128);
			this.btnBorrar4.Name = "btnBorrar4";
			this.btnBorrar4.Size = new System.Drawing.Size(24, 24);
			this.btnBorrar4.TabIndex = 52;
			this.btnBorrar4.Text = "X";
			this.btnBorrar4.Click += new System.EventHandler(this.BtnBorrar4Click);
			// 
			// btnBorrar5
			// 
			this.btnBorrar5.Location = new System.Drawing.Point(504, 152);
			this.btnBorrar5.Name = "btnBorrar5";
			this.btnBorrar5.Size = new System.Drawing.Size(24, 24);
			this.btnBorrar5.TabIndex = 53;
			this.btnBorrar5.Text = "X";
			this.btnBorrar5.Click += new System.EventHandler(this.BtnBorrar5Click);
			// 
			// txtCantidad3
			// 
			this.txtCantidad3.Location = new System.Drawing.Point(336, 104);
			this.txtCantidad3.Name = "txtCantidad3";
			this.txtCantidad3.Size = new System.Drawing.Size(80, 20);
			this.txtCantidad3.TabIndex = 27;
			this.txtCantidad3.Text = "";
			// 
			// btnBorrar7
			// 
			this.btnBorrar7.Location = new System.Drawing.Point(504, 200);
			this.btnBorrar7.Name = "btnBorrar7";
			this.btnBorrar7.Size = new System.Drawing.Size(24, 24);
			this.btnBorrar7.TabIndex = 55;
			this.btnBorrar7.Text = "X";
			this.btnBorrar7.Click += new System.EventHandler(this.BtnBorrar7Click);
			// 
			// txtCantidad1
			// 
			this.txtCantidad1.Location = new System.Drawing.Point(336, 56);
			this.txtCantidad1.Name = "txtCantidad1";
			this.txtCantidad1.Size = new System.Drawing.Size(80, 20);
			this.txtCantidad1.TabIndex = 25;
			this.txtCantidad1.Text = "";
			// 
			// btnBorrar1
			// 
			this.btnBorrar1.Location = new System.Drawing.Point(504, 56);
			this.btnBorrar1.Name = "btnBorrar1";
			this.btnBorrar1.Size = new System.Drawing.Size(24, 24);
			this.btnBorrar1.TabIndex = 48;
			this.btnBorrar1.Text = "X";
			this.btnBorrar1.Click += new System.EventHandler(this.BtnBorrar1Click);
			// 
			// btnBorrar2
			// 
			this.btnBorrar2.Location = new System.Drawing.Point(504, 80);
			this.btnBorrar2.Name = "btnBorrar2";
			this.btnBorrar2.Size = new System.Drawing.Size(24, 24);
			this.btnBorrar2.TabIndex = 50;
			this.btnBorrar2.Text = "X";
			this.btnBorrar2.Click += new System.EventHandler(this.BtnBorrar2Click);
			// 
			// txtCantidad4
			// 
			this.txtCantidad4.Location = new System.Drawing.Point(336, 128);
			this.txtCantidad4.Name = "txtCantidad4";
			this.txtCantidad4.Size = new System.Drawing.Size(80, 20);
			this.txtCantidad4.TabIndex = 28;
			this.txtCantidad4.Text = "";
			// 
			// txtCantidad5
			// 
			this.txtCantidad5.Location = new System.Drawing.Point(336, 154);
			this.txtCantidad5.Name = "txtCantidad5";
			this.txtCantidad5.Size = new System.Drawing.Size(80, 20);
			this.txtCantidad5.TabIndex = 29;
			this.txtCantidad5.Text = "";
			// 
			// btnAbrir
			// 
			this.btnAbrir.Location = new System.Drawing.Point(368, 80);
			this.btnAbrir.Name = "btnAbrir";
			this.btnAbrir.Size = new System.Drawing.Size(104, 24);
			this.btnAbrir.TabIndex = 6;
			this.btnAbrir.Text = "Abrir";
			this.btnAbrir.Click += new System.EventHandler(this.BtnAbrirClick);
			// 
			// txtCantidad8
			// 
			this.txtCantidad8.Location = new System.Drawing.Point(336, 224);
			this.txtCantidad8.Name = "txtCantidad8";
			this.txtCantidad8.Size = new System.Drawing.Size(80, 20);
			this.txtCantidad8.TabIndex = 32;
			this.txtCantidad8.Text = "";
			// 
			// txtCantidad9
			// 
			this.txtCantidad9.Location = new System.Drawing.Point(336, 248);
			this.txtCantidad9.Name = "txtCantidad9";
			this.txtCantidad9.Size = new System.Drawing.Size(80, 20);
			this.txtCantidad9.TabIndex = 33;
			this.txtCantidad9.Text = "";
			// 
			// lblObservaciones
			// 
			this.lblObservaciones.Location = new System.Drawing.Point(32, 120);
			this.lblObservaciones.Name = "lblObservaciones";
			this.lblObservaciones.Size = new System.Drawing.Size(136, 24);
			this.lblObservaciones.TabIndex = 17;
			this.lblObservaciones.Text = "Observaciones";
			// 
			// btnSelect11
			// 
			this.btnSelect11.Location = new System.Drawing.Point(528, 296);
			this.btnSelect11.Name = "btnSelect11";
			this.btnSelect11.Size = new System.Drawing.Size(32, 24);
			this.btnSelect11.TabIndex = 69;
			this.btnSelect11.Text = "->";
			this.btnSelect11.Click += new System.EventHandler(this.BtnSelect11Click);
			// 
			// btnSelect10
			// 
			this.btnSelect10.Location = new System.Drawing.Point(528, 272);
			this.btnSelect10.Name = "btnSelect10";
			this.btnSelect10.Size = new System.Drawing.Size(32, 24);
			this.btnSelect10.TabIndex = 68;
			this.btnSelect10.Text = "->";
			this.btnSelect10.Click += new System.EventHandler(this.BtnSelect10Click);
			// 
			// Unidades9
			// 
			this.Unidades9.Enabled = false;
			this.Unidades9.Location = new System.Drawing.Point(448, 248);
			this.Unidades9.Name = "Unidades9";
			this.Unidades9.Size = new System.Drawing.Size(40, 20);
			this.Unidades9.TabIndex = 44;
			this.Unidades9.Text = "";
			this.Unidades9.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			// 
			// txtCantidad11
			// 
			this.txtCantidad11.Location = new System.Drawing.Point(336, 296);
			this.txtCantidad11.Name = "txtCantidad11";
			this.txtCantidad11.Size = new System.Drawing.Size(80, 20);
			this.txtCantidad11.TabIndex = 35;
			this.txtCantidad11.Text = "";
			// 
			// txtCantidad10
			// 
			this.txtCantidad10.Location = new System.Drawing.Point(336, 272);
			this.txtCantidad10.Name = "txtCantidad10";
			this.txtCantidad10.Size = new System.Drawing.Size(80, 20);
			this.txtCantidad10.TabIndex = 34;
			this.txtCantidad10.Text = "";
			// 
			// Unidades6
			// 
			this.Unidades6.Enabled = false;
			this.Unidades6.Location = new System.Drawing.Point(448, 176);
			this.Unidades6.Name = "Unidades6";
			this.Unidades6.Size = new System.Drawing.Size(40, 20);
			this.Unidades6.TabIndex = 41;
			this.Unidades6.Text = "";
			this.Unidades6.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			// 
			// Unidades5
			// 
			this.Unidades5.Enabled = false;
			this.Unidades5.Location = new System.Drawing.Point(448, 152);
			this.Unidades5.Name = "Unidades5";
			this.Unidades5.Size = new System.Drawing.Size(40, 20);
			this.Unidades5.TabIndex = 40;
			this.Unidades5.Text = "";
			this.Unidades5.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			// 
			// Unidades4
			// 
			this.Unidades4.Enabled = false;
			this.Unidades4.Location = new System.Drawing.Point(448, 128);
			this.Unidades4.Name = "Unidades4";
			this.Unidades4.Size = new System.Drawing.Size(40, 20);
			this.Unidades4.TabIndex = 39;
			this.Unidades4.Text = "";
			this.Unidades4.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			// 
			// Unidades3
			// 
			this.Unidades3.Enabled = false;
			this.Unidades3.Location = new System.Drawing.Point(448, 104);
			this.Unidades3.Name = "Unidades3";
			this.Unidades3.Size = new System.Drawing.Size(40, 20);
			this.Unidades3.TabIndex = 38;
			this.Unidades3.Text = "";
			this.Unidades3.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			// 
			// Unidades2
			// 
			this.Unidades2.Enabled = false;
			this.Unidades2.Location = new System.Drawing.Point(448, 80);
			this.Unidades2.Name = "Unidades2";
			this.Unidades2.Size = new System.Drawing.Size(40, 20);
			this.Unidades2.TabIndex = 37;
			this.Unidades2.Text = "";
			this.Unidades2.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			// 
			// Unidades1
			// 
			this.Unidades1.Enabled = false;
			this.Unidades1.Location = new System.Drawing.Point(448, 56);
			this.Unidades1.Name = "Unidades1";
			this.Unidades1.Size = new System.Drawing.Size(40, 20);
			this.Unidades1.TabIndex = 36;
			this.Unidades1.Text = "";
			this.Unidades1.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			// 
			// txtProspecto
			// 
			this.txtProspecto.Location = new System.Drawing.Point(176, 80);
			this.txtProspecto.Name = "txtProspecto";
			this.txtProspecto.Size = new System.Drawing.Size(176, 20);
			this.txtProspecto.TabIndex = 5;
			this.txtProspecto.Text = "";
			// 
			// btnImprimir
			// 
			this.btnImprimir.Location = new System.Drawing.Point(608, 368);
			this.btnImprimir.Name = "btnImprimir";
			this.btnImprimir.Size = new System.Drawing.Size(128, 24);
			this.btnImprimir.TabIndex = 11;
			this.btnImprimir.Text = "Imprimir";
			this.btnImprimir.Click += new System.EventHandler(this.BtnImprimirClick);
			// 
			// lblComponenteID
			// 
			this.lblComponenteID.Location = new System.Drawing.Point(32, 32);
			this.lblComponenteID.Name = "lblComponenteID";
			this.lblComponenteID.Size = new System.Drawing.Size(88, 16);
			this.lblComponenteID.TabIndex = 11;
			this.lblComponenteID.Text = "ComponenteID";
			// 
			// txtNombre8
			// 
			this.txtNombre8.Location = new System.Drawing.Point(136, 224);
			this.txtNombre8.Name = "txtNombre8";
			this.txtNombre8.Size = new System.Drawing.Size(176, 20);
			this.txtNombre8.TabIndex = 20;
			this.txtNombre8.Text = "";
			// 
			// txtNombre2
			// 
			this.txtNombre2.Location = new System.Drawing.Point(136, 80);
			this.txtNombre2.Name = "txtNombre2";
			this.txtNombre2.Size = new System.Drawing.Size(176, 20);
			this.txtNombre2.TabIndex = 16;
			this.txtNombre2.Text = "";
			// 
			// txtNombre1
			// 
			this.txtNombre1.Location = new System.Drawing.Point(136, 56);
			this.txtNombre1.Name = "txtNombre1";
			this.txtNombre1.Size = new System.Drawing.Size(176, 20);
			this.txtNombre1.TabIndex = 13;
			this.txtNombre1.Text = "";
			// 
			// lblProspecto
			// 
			this.lblProspecto.Location = new System.Drawing.Point(32, 88);
			this.lblProspecto.Name = "lblProspecto";
			this.lblProspecto.Size = new System.Drawing.Size(136, 24);
			this.lblProspecto.TabIndex = 2;
			this.lblProspecto.Text = "Prospecto";
			// 
			// txtNombre4
			// 
			this.txtNombre4.Location = new System.Drawing.Point(136, 128);
			this.txtNombre4.Name = "txtNombre4";
			this.txtNombre4.Size = new System.Drawing.Size(176, 20);
			this.txtNombre4.TabIndex = 14;
			this.txtNombre4.Text = "";
			// 
			// lblPos
			// 
			this.lblPos.Location = new System.Drawing.Point(88, 240);
			this.lblPos.Name = "lblPos";
			this.lblPos.Size = new System.Drawing.Size(120, 16);
			this.lblPos.TabIndex = 12;
			this.lblPos.Text = "0 de 0";
			this.lblPos.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// lblFormulaID
			// 
			this.lblFormulaID.Location = new System.Drawing.Point(32, 24);
			this.lblFormulaID.Name = "lblFormulaID";
			this.lblFormulaID.Size = new System.Drawing.Size(136, 24);
			this.lblFormulaID.TabIndex = 0;
			this.lblFormulaID.Text = "Formula ID";
			// 
			// btnGuardar
			// 
			this.btnGuardar.Location = new System.Drawing.Point(608, 304);
			this.btnGuardar.Name = "btnGuardar";
			this.btnGuardar.Size = new System.Drawing.Size(128, 24);
			this.btnGuardar.TabIndex = 9;
			this.btnGuardar.Text = "Guardar";
			this.btnGuardar.Click += new System.EventHandler(this.BtnGuardarClick);
			// 
			// txtFormulaID
			// 
			this.txtFormulaID.Location = new System.Drawing.Point(176, 16);
			this.txtFormulaID.Name = "txtFormulaID";
			this.txtFormulaID.Size = new System.Drawing.Size(56, 20);
			this.txtFormulaID.TabIndex = 3;
			this.txtFormulaID.Text = "";
			// 
			// lblNombre
			// 
			this.lblNombre.Location = new System.Drawing.Point(32, 56);
			this.lblNombre.Name = "lblNombre";
			this.lblNombre.Size = new System.Drawing.Size(136, 24);
			this.lblNombre.TabIndex = 1;
			this.lblNombre.Text = "Nombre";
			// 
			// txtNombre10
			// 
			this.txtNombre10.Location = new System.Drawing.Point(136, 272);
			this.txtNombre10.Name = "txtNombre10";
			this.txtNombre10.Size = new System.Drawing.Size(176, 20);
			this.txtNombre10.TabIndex = 22;
			this.txtNombre10.Text = "";
			// 
			// txtNombre11
			// 
			this.txtNombre11.Location = new System.Drawing.Point(136, 296);
			this.txtNombre11.Name = "txtNombre11";
			this.txtNombre11.Size = new System.Drawing.Size(176, 20);
			this.txtNombre11.TabIndex = 23;
			this.txtNombre11.Text = "";
			// 
			// lblCantidad
			// 
			this.lblCantidad.Location = new System.Drawing.Point(336, 32);
			this.lblCantidad.Name = "lblCantidad";
			this.lblCantidad.Size = new System.Drawing.Size(80, 16);
			this.lblCantidad.TabIndex = 24;
			this.lblCantidad.Text = "Cantidad";
			// 
			// lblNombres
			// 
			this.lblNombres.Location = new System.Drawing.Point(144, 32);
			this.lblNombres.Name = "lblNombres";
			this.lblNombres.Size = new System.Drawing.Size(112, 16);
			this.lblNombres.TabIndex = 12;
			this.lblNombres.Text = "Nombre";
			// 
			// lblUnidades
			// 
			this.lblUnidades.Location = new System.Drawing.Point(448, 32);
			this.lblUnidades.Name = "lblUnidades";
			this.lblUnidades.Size = new System.Drawing.Size(56, 16);
			this.lblUnidades.TabIndex = 47;
			this.lblUnidades.Text = "Unidades";
			// 
			// btnBorrar11
			// 
			this.btnBorrar11.Location = new System.Drawing.Point(504, 296);
			this.btnBorrar11.Name = "btnBorrar11";
			this.btnBorrar11.Size = new System.Drawing.Size(24, 24);
			this.btnBorrar11.TabIndex = 59;
			this.btnBorrar11.Text = "X";
			this.btnBorrar11.Click += new System.EventHandler(this.BtnBorrar11Click);
			// 
			// btnBorrar10
			// 
			this.btnBorrar10.Location = new System.Drawing.Point(504, 272);
			this.btnBorrar10.Name = "btnBorrar10";
			this.btnBorrar10.Size = new System.Drawing.Size(24, 24);
			this.btnBorrar10.TabIndex = 58;
			this.btnBorrar10.Text = "X";
			this.btnBorrar10.Click += new System.EventHandler(this.BtnBorrar10Click);
			// 
			// FormulasForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(762, 615);
			this.Controls.Add(this.txtObservaciones);
			this.Controls.Add(this.lblObservaciones);
			this.Controls.Add(this.btnLast);
			this.Controls.Add(this.btnNext);
			this.Controls.Add(this.btnPrev);
			this.Controls.Add(this.btnFirst);
			this.Controls.Add(this.lblPos);
			this.Controls.Add(this.btnImprimir);
			this.Controls.Add(this.btnBorrar);
			this.Controls.Add(this.btnGuardar);
			this.Controls.Add(this.btnNuevo);
			this.Controls.Add(this.grpComponentes);
			this.Controls.Add(this.btnAbrir);
			this.Controls.Add(this.txtProspecto);
			this.Controls.Add(this.txtNombre);
			this.Controls.Add(this.txtFormulaID);
			this.Controls.Add(this.lblProspecto);
			this.Controls.Add(this.lblNombre);
			this.Controls.Add(this.lblFormulaID);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "FormulasForm";
			this.Text = "Gestion de Formulas";
			this.Load += new System.EventHandler(this.FormulasFormLoad);
			this.grpComponentes.ResumeLayout(false);
			this.ResumeLayout(false);
		}
		#endregion
		void FormulasFormLoad(object sender, System.EventArgs e)
		{
			this.CargarConfiguracionDatabase();
			AlertaLocal.setConnectionParameters(this.dbhost ,this.dbport ,this.dbuser ,this.dbpasoteword ,"formulacion");
			if ( this.Conectar() )
			{
				this.RecPosition = 0;
				this.CargarComandoUpdate();
				this.CargarComandoInsert();
				this.CargarComandoDelete();
				this.RecCount = ds.Tables[0].Rows.Count;
				
			    MostrarPosicion();
			    this.CargarRegistro(this.RecPosition);
			}
			

		}
		
		void MostrarPosicion(){
			this.lblPos.Text = (this.RecPosition+1).ToString() + " de " + this.RecCount.ToString();
		}

		void CargarRegistro( int numero){

			try{
			if( numero >=0 && numero < ds.Tables[0].Rows.Count)
			{
				this.txtFormulaID.Text = ds.Tables[0].Rows[numero]["FormulaID"].ToString();
				this.txtNombre.Text = ds.Tables[0].Rows[numero]["Nombre"].ToString();
				this.txtProspecto.Text = ds.Tables[0].Rows[numero]["Prospecto"].ToString();
				this.txtObservaciones.Text = ds.Tables[0].Rows[numero]["Observaciones"].ToString();
				CargarComponentes(numero);
			}
			}catch(Exception ex){
				FM_Errores.MostrarError("CargarRegistro","No se puede cargar el registro",ex);
			}
		}

		void LimpiarCajas(){
			
				this.txtComponenteID1.Clear();
				this.txtCantidad1.Clear();
				this.txtNombre1.Clear();
				this.Unidades1.Clear();

				this.txtComponenteID2.Clear();
				this.txtCantidad2.Clear();
				this.txtNombre2.Clear();
				this.Unidades2.Clear();

				this.txtComponenteID3.Clear();
				this.txtCantidad3.Clear();
				this.txtNombre3.Clear();
				this.Unidades3.Clear();
				
				this.txtComponenteID4.Clear();
				this.txtCantidad4.Clear();
				this.txtNombre4.Clear();
				this.Unidades4.Clear();
				
				this.txtComponenteID5.Clear();
				this.txtCantidad5.Clear();
				this.txtNombre5.Clear();
				this.Unidades5.Clear();
				
				this.txtComponenteID6.Clear();
				this.txtCantidad6.Clear();
				this.txtNombre6.Clear();
				this.Unidades6.Clear();
				
				this.txtComponenteID7.Clear();
				this.txtCantidad7.Clear();
				this.txtNombre7.Clear();
				this.Unidades7.Clear();
				
				this.txtComponenteID8.Clear();
				this.txtCantidad8.Clear();
				this.txtNombre8.Clear();
				this.Unidades8.Clear();
				
				this.txtComponenteID9.Clear();
				this.txtCantidad9.Clear();
				this.txtNombre9.Clear();
				this.Unidades9.Clear();
				
				this.txtComponenteID10.Clear();
				this.txtCantidad10.Clear();
				this.txtNombre10.Clear();
				this.Unidades10.Clear();
				
				this.txtComponenteID11.Clear();
				this.txtCantidad11.Clear();
				this.txtNombre11.Clear();
				this.Unidades11.Clear();
				
		}
		void CargarComponentes(int numero){

			int formulaid;
			try{
				this.LimpiarCajas();
			if( numero >=0 && numero < ds.Tables[0].Rows.Count)
			{
				formulaid = Convert.ToInt32 ( ds.Tables[0].Rows[numero]["FormulaID"]);
				
				
				if( formulaid <= 0)
					return;
						
				adapComps.SelectCommand = new MySqlCommand("SELECT * From componentes_formulas WHERE FormulaID = " + formulaid.ToString() + ";",conn);
				dsComps.Clear();
				adapComps.Fill(dsComps,"Componentes");
				
				if( dsComps.Tables[0].Rows.Count <= 0){
					return;
				}
				if( dsComps.Tables[0].Rows.Count > 11){
					FM_Errores.MostrarError("CargarComponentes","No se puede cargar los componentes porque exceden la capacidad de la aplicacin");
				}else{
					string[] res;
					for(int i=0; i< dsComps.Tables[0].Rows.Count; ++i){
						switch(i){
								case 0: 
								this.txtComponenteID1.Text = dsComps.Tables[0].Rows[i]["MateriaID"].ToString();
								this.txtCantidad1.Text = dsComps.Tables[0].Rows[i]["Cantidad"].ToString();
								res = Dispensacion_rutinas.get_componente_details("host="+this.dbhost+";port=" + this.dbport + ";user id="+this.dbuser+";password="+this.dbpasoteword+ ";database=formulacion", Convert.ToInt32(dsComps.Tables[0].Rows[i]["MateriaID"]));
								this.txtNombre1.Text = res[0];
								this.Unidades1.Text = res[1];
								break;
								case 1: 
								this.txtComponenteID2.Text = dsComps.Tables[0].Rows[i]["MateriaID"].ToString();
								this.txtCantidad2.Text = dsComps.Tables[0].Rows[i]["Cantidad"].ToString();
								res = Dispensacion_rutinas.get_componente_details("host="+this.dbhost+";port=" + this.dbport + ";user id="+this.dbuser+";password="+this.dbpasoteword+ ";database=formulacion", Convert.ToInt32(dsComps.Tables[0].Rows[i]["MateriaID"]));
								this.txtNombre2.Text = res[0];
								this.Unidades2.Text = res[1];
								break;
								case 2: 
								this.txtComponenteID3.Text = dsComps.Tables[0].Rows[i]["MateriaID"].ToString();
								this.txtCantidad3.Text = dsComps.Tables[0].Rows[i]["Cantidad"].ToString();
								res = Dispensacion_rutinas.get_componente_details("host="+this.dbhost+";port=" + this.dbport + ";user id="+this.dbuser+";password="+this.dbpasoteword+ ";database=formulacion", Convert.ToInt32(dsComps.Tables[0].Rows[i]["MateriaID"]));
								this.txtNombre3.Text = res[0];
								this.Unidades3.Text = res[1];
								break;
								case 3: 
								this.txtComponenteID4.Text = dsComps.Tables[0].Rows[i]["MateriaID"].ToString();
								this.txtCantidad4.Text = dsComps.Tables[0].Rows[i]["Cantidad"].ToString();
								res = Dispensacion_rutinas.get_componente_details("host="+this.dbhost+";port=" + this.dbport + ";user id="+this.dbuser+";password="+this.dbpasoteword+ ";database=formulacion", Convert.ToInt32(dsComps.Tables[0].Rows[i]["MateriaID"]));
								this.txtNombre4.Text = res[0];
								this.Unidades4.Text = res[1];
								break;
								case 4: 
								this.txtComponenteID5.Text = dsComps.Tables[0].Rows[i]["MateriaID"].ToString();
								this.txtCantidad5.Text = dsComps.Tables[0].Rows[i]["Cantidad"].ToString();
								res = Dispensacion_rutinas.get_componente_details("host="+this.dbhost+";port=" + this.dbport + ";user id="+this.dbuser+";password="+this.dbpasoteword+ ";database=formulacion", Convert.ToInt32(dsComps.Tables[0].Rows[i]["MateriaID"]));
								this.txtNombre5.Text = res[0];
								this.Unidades5.Text = res[1];
								break;
								case 5: 
								this.txtComponenteID6.Text = dsComps.Tables[0].Rows[i]["MateriaID"].ToString();
								this.txtCantidad6.Text = dsComps.Tables[0].Rows[i]["Cantidad"].ToString();
								res = Dispensacion_rutinas.get_componente_details("host="+this.dbhost+";port=" + this.dbport + ";user id="+this.dbuser+";password="+this.dbpasoteword+ ";database=formulacion", Convert.ToInt32(dsComps.Tables[0].Rows[i]["MateriaID"]));
								this.txtNombre6.Text = res[0];
								this.Unidades6.Text = res[1];
								break;
								case 6: 
								this.txtComponenteID7.Text = dsComps.Tables[0].Rows[i]["MateriaID"].ToString();
								this.txtCantidad7.Text = dsComps.Tables[0].Rows[i]["Cantidad"].ToString();
								res = Dispensacion_rutinas.get_componente_details("host="+this.dbhost+";port=" + this.dbport + ";user id="+this.dbuser+";password="+this.dbpasoteword+ ";database=formulacion", Convert.ToInt32(dsComps.Tables[0].Rows[i]["MateriaID"]));
								this.txtNombre7.Text = res[0];
								this.Unidades7.Text = res[1];
								break;
								case 7: 
								this.txtComponenteID8.Text = dsComps.Tables[0].Rows[i]["MateriaID"].ToString();
								this.txtCantidad8.Text = dsComps.Tables[0].Rows[i]["Cantidad"].ToString();
								res = Dispensacion_rutinas.get_componente_details("host="+this.dbhost+";port=" + this.dbport + ";user id="+this.dbuser+";password="+this.dbpasoteword+ ";database=formulacion", Convert.ToInt32(dsComps.Tables[0].Rows[i]["MateriaID"]));
								this.txtNombre8.Text = res[0];
								this.Unidades8.Text = res[1];
								break;
								case 8: 
								this.txtComponenteID9.Text = dsComps.Tables[0].Rows[i]["MateriaID"].ToString();
								this.txtCantidad9.Text = dsComps.Tables[0].Rows[i]["Cantidad"].ToString();
								res = Dispensacion_rutinas.get_componente_details("host="+this.dbhost+";port=" + this.dbport + ";user id="+this.dbuser+";password="+this.dbpasoteword+ ";database=formulacion", Convert.ToInt32(dsComps.Tables[0].Rows[i]["MateriaID"]));
								this.txtNombre9.Text = res[0];
								this.Unidades9.Text = res[1];
								break;
								case 9: 
								this.txtComponenteID10.Text = dsComps.Tables[0].Rows[i]["MateriaID"].ToString();
								this.txtCantidad10.Text = dsComps.Tables[0].Rows[i]["Cantidad"].ToString();
								res = Dispensacion_rutinas.get_componente_details("host="+this.dbhost+";port=" + this.dbport + ";user id="+this.dbuser+";password="+this.dbpasoteword+ ";database=formulacion", Convert.ToInt32(dsComps.Tables[0].Rows[i]["MateriaID"]));
								this.txtNombre10.Text = res[0];
								this.Unidades10.Text = res[1];
								break;
								case 10: 
								this.txtComponenteID11.Text = dsComps.Tables[0].Rows[i]["MateriaID"].ToString();
								this.txtCantidad11.Text = dsComps.Tables[0].Rows[i]["Cantidad"].ToString();
								res = Dispensacion_rutinas.get_componente_details("host="+this.dbhost+";port=" + this.dbport + ";user id="+this.dbuser+";password="+this.dbpasoteword+ ";database=formulacion", Convert.ToInt32(dsComps.Tables[0].Rows[i]["MateriaID"]));
								this.txtNombre11.Text = res[0];
								this.Unidades11.Text = res[1];
								break;
								

						}
					}
				}
			}
			}catch(Exception ex){
				FM_Errores.MostrarError("CargarComponenetes","No se pueden cargar los componentes de la formula",ex);
			}

		}
		
		void BtnSelect1Click(object sender, System.EventArgs e)
		{
			
			if( this.txtCantidad1.Text.Length == 0)
				this.txtCantidad1.Text = "1";
			
			if( dsComps.Tables[0].Rows.Count <= 0)
			{
				dsComps.Tables[0].Rows.Add(new Object[dsComps.Tables[0].Columns.Count]);
			}
				
			try{
			MateriasForm mtf1 = new MateriasForm(this.currentlevel);
			mtf1.ShowDialog();
			dsComps.Tables[0].Rows[0].BeginEdit();
			dsComps.Tables[0].Rows[0]["MateriaID"] = mtf1.getcurrentid();
			dsComps.Tables[0].Rows[0]["FormulaID"] = this.txtFormulaID.Text;
			dsComps.Tables[0].Rows[0]["Cantidad"] = this.txtCantidad1.Text;
			dsComps.Tables[0].Rows[0].EndEdit();
			this.adapComps.Update(dsComps,"Componentes");
			
			mtf1.Dispose();
			this.CargarComponentes(this.RecPosition);

			}catch(Exception ex){
				FM_Errores.MostrarError("MostrarMateriasRegistro","No se puede mostrar la ventana",ex);
			}
			
		}
		
		void BtnSelect2Click(object sender, System.EventArgs e)
		{
			if( this.txtCantidad2.Text.Length == 0)
				this.txtCantidad2.Text = "1";
			
			if( dsComps.Tables[0].Rows.Count <= 1)
			{
				dsComps.Tables[0].Rows.Add(new Object[dsComps.Tables[0].Columns.Count]);
			}
				
			try{
			MateriasForm mtf1 = new MateriasForm(this.currentlevel);
			mtf1.ShowDialog();
			dsComps.Tables[0].Rows[1].BeginEdit();
			dsComps.Tables[0].Rows[1]["MateriaID"] = mtf1.getcurrentid();
			dsComps.Tables[0].Rows[1]["FormulaID"] = this.txtFormulaID.Text;
			dsComps.Tables[0].Rows[1]["Cantidad"] = this.txtCantidad2.Text;
			dsComps.Tables[0].Rows[1].EndEdit();
			this.adapComps.Update(dsComps,"Componentes");
			
			mtf1.Dispose();
			this.CargarComponentes(this.RecPosition);

			}catch(Exception ex){
				FM_Errores.MostrarError("MostrarMateriasRegistro","No se puede mostrar la ventana",ex);
			}

		}
		
		void BtnSelect3Click(object sender, System.EventArgs e)
		{
			if( this.txtCantidad3.Text.Length == 0)
				this.txtCantidad3.Text = "1";
			
			if( dsComps.Tables[0].Rows.Count <= 2)
			{
				dsComps.Tables[0].Rows.Add(new Object[dsComps.Tables[0].Columns.Count]);
			}
				
			try{
			MateriasForm mtf1 = new MateriasForm(this.currentlevel);
			mtf1.ShowDialog();
			dsComps.Tables[0].Rows[2].BeginEdit();
			dsComps.Tables[0].Rows[2]["MateriaID"] = mtf1.getcurrentid();
			dsComps.Tables[0].Rows[2]["FormulaID"] = this.txtFormulaID.Text;
			dsComps.Tables[0].Rows[2]["Cantidad"] = this.txtCantidad3.Text;
			dsComps.Tables[0].Rows[2].EndEdit();
			this.adapComps.Update(dsComps,"Componentes");
			
			mtf1.Dispose();
			this.CargarComponentes(this.RecPosition);

			}catch(Exception ex){
				FM_Errores.MostrarError("MostrarMateriasRegistro","No se puede mostrar la ventana",ex);
			}

		}
		
		void BtnSelect4Click(object sender, System.EventArgs e)
		{
			if( this.txtCantidad4.Text.Length == 0)
				this.txtCantidad4.Text = "1";
			
			if( dsComps.Tables[0].Rows.Count <= 3)
			{
				dsComps.Tables[0].Rows.Add(new Object[dsComps.Tables[0].Columns.Count]);
			}
				
			try{
			MateriasForm mtf1 = new MateriasForm(this.currentlevel);
			mtf1.ShowDialog();
			dsComps.Tables[0].Rows[3].BeginEdit();
			dsComps.Tables[0].Rows[3]["MateriaID"] = mtf1.getcurrentid();
			dsComps.Tables[0].Rows[3]["FormulaID"] = this.txtFormulaID.Text;
			dsComps.Tables[0].Rows[3]["Cantidad"] = this.txtCantidad4.Text;
			dsComps.Tables[0].Rows[3].EndEdit();
			this.adapComps.Update(dsComps,"Componentes");
			
			mtf1.Dispose();
			this.CargarComponentes(this.RecPosition);

			}catch(Exception ex){
				FM_Errores.MostrarError("MostrarMateriasRegistro","No se puede mostrar la ventana",ex);
			}


		}

		
		void BtnSelect5Click(object sender, System.EventArgs e)
		{
			if( this.txtCantidad5.Text.Length == 0)
				this.txtCantidad5.Text = "1";
			
			if( dsComps.Tables[0].Rows.Count <= 4)
			{
				dsComps.Tables[0].Rows.Add(new Object[dsComps.Tables[0].Columns.Count]);
			}
				
			try{
			MateriasForm mtf1 = new MateriasForm(this.currentlevel);
			mtf1.ShowDialog();
			dsComps.Tables[0].Rows[4].BeginEdit();
			dsComps.Tables[0].Rows[4]["MateriaID"] = mtf1.getcurrentid();
			dsComps.Tables[0].Rows[4]["FormulaID"] = this.txtFormulaID.Text;
			dsComps.Tables[0].Rows[4]["Cantidad"] = this.txtCantidad5.Text;
			dsComps.Tables[0].Rows[4].EndEdit();
			this.adapComps.Update(dsComps,"Componentes");
			
			mtf1.Dispose();
			this.CargarComponentes(this.RecPosition);

			}catch(Exception ex){
				FM_Errores.MostrarError("MostrarMateriasRegistro","No se puede mostrar la ventana",ex);
			}


		}

		void BtnSelect6Click(object sender, System.EventArgs e)
		{
			if( this.txtCantidad6.Text.Length == 0)
				this.txtCantidad6.Text = "1";
			
			if( dsComps.Tables[0].Rows.Count <= 5)
			{
				dsComps.Tables[0].Rows.Add(new Object[dsComps.Tables[0].Columns.Count]);
			}
				
			try{
			MateriasForm mtf1 = new MateriasForm(this.currentlevel);
			mtf1.ShowDialog();
			dsComps.Tables[0].Rows[5].BeginEdit();
			dsComps.Tables[0].Rows[5]["MateriaID"] = mtf1.getcurrentid();
			dsComps.Tables[0].Rows[5]["FormulaID"] = this.txtFormulaID.Text;
			dsComps.Tables[0].Rows[5]["Cantidad"] = this.txtCantidad6.Text;
			dsComps.Tables[0].Rows[5].EndEdit();
			this.adapComps.Update(dsComps,"Componentes");
			
			mtf1.Dispose();
			this.CargarComponentes(this.RecPosition);

			}catch(Exception ex){
				FM_Errores.MostrarError("MostrarMateriasRegistro","No se puede mostrar la ventana",ex);
			}


		}

		void BtnSelect7Click(object sender, System.EventArgs e)
		{
			if( this.txtCantidad7.Text.Length == 0)
				this.txtCantidad7.Text = "1";
			
			if( dsComps.Tables[0].Rows.Count <= 6)
			{
				dsComps.Tables[0].Rows.Add(new Object[dsComps.Tables[0].Columns.Count]);
			}
				
			try{
			MateriasForm mtf1 = new MateriasForm(this.currentlevel);
			mtf1.ShowDialog();
			dsComps.Tables[0].Rows[6].BeginEdit();
			dsComps.Tables[0].Rows[6]["MateriaID"] = mtf1.getcurrentid();
			dsComps.Tables[0].Rows[6]["FormulaID"] = this.txtFormulaID.Text;
			dsComps.Tables[0].Rows[6]["Cantidad"] = this.txtCantidad7.Text;
			dsComps.Tables[0].Rows[6].EndEdit();
			this.adapComps.Update(dsComps,"Componentes");
			
			mtf1.Dispose();
			this.CargarComponentes(this.RecPosition);

			}catch(Exception ex){
				FM_Errores.MostrarError("MostrarMateriasRegistro","No se puede mostrar la ventana",ex);
			}
		}


		void BtnSelect8Click(object sender, System.EventArgs e)
		{
			if( this.txtCantidad8.Text.Length == 0)
				this.txtCantidad8.Text = "1";
			
			if( dsComps.Tables[0].Rows.Count <= 7)
			{
				dsComps.Tables[0].Rows.Add(new Object[dsComps.Tables[0].Columns.Count]);
			}
				
			try{
			MateriasForm mtf1 = new MateriasForm(this.currentlevel);
			mtf1.ShowDialog();
			dsComps.Tables[0].Rows[7].BeginEdit();
			dsComps.Tables[0].Rows[7]["MateriaID"] = mtf1.getcurrentid();
			dsComps.Tables[0].Rows[7]["FormulaID"] = this.txtFormulaID.Text;
			dsComps.Tables[0].Rows[7]["Cantidad"] = this.txtCantidad8.Text;
			dsComps.Tables[0].Rows[7].EndEdit();
			this.adapComps.Update(dsComps,"Componentes");
			
			mtf1.Dispose();
			this.CargarComponentes(this.RecPosition);

			}catch(Exception ex){
				FM_Errores.MostrarError("MostrarMateriasRegistro","No se puede mostrar la ventana",ex);
			}
		}

		void BtnSelect9Click(object sender, System.EventArgs e)
		{
			if( this.txtCantidad9.Text.Length == 0)
				this.txtCantidad9.Text = "1";
			
			if( dsComps.Tables[0].Rows.Count <= 8)
			{
				dsComps.Tables[0].Rows.Add(new Object[dsComps.Tables[0].Columns.Count]);
			}
				
			try{
			MateriasForm mtf1 = new MateriasForm(this.currentlevel);
			mtf1.ShowDialog();
			dsComps.Tables[0].Rows[8].BeginEdit();
			dsComps.Tables[0].Rows[8]["MateriaID"] = mtf1.getcurrentid();
			dsComps.Tables[0].Rows[8]["FormulaID"] = this.txtFormulaID.Text;
			dsComps.Tables[0].Rows[8]["Cantidad"] = this.txtCantidad9.Text;
			dsComps.Tables[0].Rows[8].EndEdit();
			this.adapComps.Update(dsComps,"Componentes");
			
			mtf1.Dispose();
			this.CargarComponentes(this.RecPosition);

			}catch(Exception ex){
				FM_Errores.MostrarError("MostrarMateriasRegistro","No se puede mostrar la ventana",ex);
			}
		}

		void BtnSelect10Click(object sender, System.EventArgs e)
		{
			if( this.txtCantidad10.Text.Length == 0)
				this.txtCantidad10.Text = "1";
			
			if( dsComps.Tables[0].Rows.Count <= 9)
			{
				dsComps.Tables[0].Rows.Add(new Object[dsComps.Tables[0].Columns.Count]);
			}
				
			try{
			MateriasForm mtf1 = new MateriasForm(this.currentlevel);
			mtf1.ShowDialog();
			dsComps.Tables[0].Rows[9].BeginEdit();
			dsComps.Tables[0].Rows[9]["MateriaID"] = mtf1.getcurrentid();
			dsComps.Tables[0].Rows[9]["FormulaID"] = this.txtFormulaID.Text;
			dsComps.Tables[0].Rows[9]["Cantidad"] = this.txtCantidad10.Text;
			dsComps.Tables[0].Rows[9].EndEdit();
			this.adapComps.Update(dsComps,"Componentes");
			
			mtf1.Dispose();
			this.CargarComponentes(this.RecPosition);

			}catch(Exception ex){
				FM_Errores.MostrarError("MostrarMateriasRegistro","No se puede mostrar la ventana",ex);
			}
		}

		void BtnSelect11Click(object sender, System.EventArgs e)
		{
			if( this.txtCantidad11.Text.Length == 0)
				this.txtCantidad11.Text = "1";
			
			if( dsComps.Tables[0].Rows.Count <= 10)
			{
				dsComps.Tables[0].Rows.Add(new Object[dsComps.Tables[0].Columns.Count]);
			}
				
			try{
			MateriasForm mtf1 = new MateriasForm(this.currentlevel);
			mtf1.ShowDialog();
			dsComps.Tables[0].Rows[10].BeginEdit();
			dsComps.Tables[0].Rows[10]["MateriaID"] = mtf1.getcurrentid();
			dsComps.Tables[0].Rows[10]["FormulaID"] = this.txtFormulaID.Text;
			dsComps.Tables[0].Rows[10]["Cantidad"] = this.txtCantidad11.Text;
			dsComps.Tables[0].Rows[10].EndEdit();
			this.adapComps.Update(dsComps,"Componentes");
			
			mtf1.Dispose();
			this.CargarComponentes(this.RecPosition);

			}catch(Exception ex){
				FM_Errores.MostrarError("MostrarMateriasRegistro","No se puede mostrar la ventana",ex);
			}
		}

		
		void BtnBorrar1Click(object sender, System.EventArgs e)
		{
			try{
			if( dsComps.Tables[0].Rows.Count >= 0)
			{
				dsComps.Tables[0].Rows[0].Delete();
				this.adapComps.Update(dsComps.Tables[0].Select("", "", DataViewRowState.Deleted));
				this.CargarComponentes(this.RecPosition);
				FM_Errores.MostrarAviso("Componente borrado correctamente");
			}
			}catch(Exception ex){
				FM_Errores.MostrarError("BorrarComponente","No se puede borrar el componenete",ex);
			}
		}
		
		void BtnBorrar2Click(object sender, System.EventArgs e)
		{
			try{
			if( dsComps.Tables[0].Rows.Count >= 1)
			{
				dsComps.Tables[0].Rows[1].Delete();
				this.adapComps.Update(dsComps.Tables[0].Select("", "", DataViewRowState.Deleted));
				this.CargarComponentes(this.RecPosition);
				FM_Errores.MostrarAviso("Componente borrado correctamente");
			}
			}catch(Exception ex){
				FM_Errores.MostrarError("BorrarComponente","No se puede borrar el componenete",ex);
			}

		}

		
		void BtnBorrar3Click(object sender, System.EventArgs e)
		{
			try{
			if( dsComps.Tables[0].Rows.Count >= 2)
			{
				dsComps.Tables[0].Rows[2].Delete();
				this.adapComps.Update(dsComps.Tables[0].Select("", "", DataViewRowState.Deleted));
				this.CargarComponentes(this.RecPosition);
				FM_Errores.MostrarAviso("Componente borrado correctamente");
			}
			}catch(Exception ex){
				FM_Errores.MostrarError("BorrarComponente","No se puede borrar el componenete",ex);
			}

		}

		void BtnBorrar4Click(object sender, System.EventArgs e)
		{
			try{
			if( dsComps.Tables[0].Rows.Count >= 3)
			{
				dsComps.Tables[0].Rows[3].Delete();
				this.adapComps.Update(dsComps.Tables[0].Select("", "", DataViewRowState.Deleted));
				this.CargarComponentes(this.RecPosition);
				FM_Errores.MostrarAviso("Componente borrado correctamente");
			}
			}catch(Exception ex){
				FM_Errores.MostrarError("BorrarComponente","No se puede borrar el componenete",ex);
			}

		}

		void BtnBorrar5Click(object sender, System.EventArgs e)
		{
			try{
			if( dsComps.Tables[0].Rows.Count >= 4)
			{
				dsComps.Tables[0].Rows[4].Delete();
				this.adapComps.Update(dsComps.Tables[0].Select("", "", DataViewRowState.Deleted));
				this.CargarComponentes(this.RecPosition);
				FM_Errores.MostrarAviso("Componente borrado correctamente");
			}
			}catch(Exception ex){
				FM_Errores.MostrarError("BorrarComponente","No se puede borrar el componenete",ex);
			}

		}
		void BtnBorrar6Click(object sender, System.EventArgs e)
		{
			try{
			if( dsComps.Tables[0].Rows.Count >= 5)
			{
				dsComps.Tables[0].Rows[5].Delete();
				this.adapComps.Update(dsComps.Tables[0].Select("", "", DataViewRowState.Deleted));
				this.CargarComponentes(this.RecPosition);
				FM_Errores.MostrarAviso("Componente borrado correctamente");
			}
			}catch(Exception ex){
				FM_Errores.MostrarError("BorrarComponente","No se puede borrar el componenete",ex);
			}

		}

		void BtnBorrar7Click(object sender, System.EventArgs e)
		{
			try{
			if( dsComps.Tables[0].Rows.Count >= 6)
			{
				dsComps.Tables[0].Rows[6].Delete();
				this.adapComps.Update(dsComps.Tables[0].Select("", "", DataViewRowState.Deleted));
				this.CargarComponentes(this.RecPosition);
				FM_Errores.MostrarAviso("Componente borrado correctamente");
			}
			}catch(Exception ex){
				FM_Errores.MostrarError("BorrarComponente","No se puede borrar el componenete",ex);
			}

		}

		void BtnBorrar8Click(object sender, System.EventArgs e)
		{
			try{
			if( dsComps.Tables[0].Rows.Count >= 7)
			{
				dsComps.Tables[0].Rows[7].Delete();
				this.adapComps.Update(dsComps.Tables[0].Select("", "", DataViewRowState.Deleted));
				this.CargarComponentes(this.RecPosition);
				FM_Errores.MostrarAviso("Componente borrado correctamente");
			}
			}catch(Exception ex){
				FM_Errores.MostrarError("BorrarComponente","No se puede borrar el componenete",ex);
			}

		}
		void BtnBorrar9Click(object sender, System.EventArgs e)
		{
			try{
			if( dsComps.Tables[0].Rows.Count >= 8)
			{
				dsComps.Tables[0].Rows[8].Delete();
				this.adapComps.Update(dsComps.Tables[0].Select("", "", DataViewRowState.Deleted));
				this.CargarComponentes(this.RecPosition);
				FM_Errores.MostrarAviso("Componente borrado correctamente");
			}
			}catch(Exception ex){
				FM_Errores.MostrarError("BorrarComponente","No se puede borrar el componenete",ex);
			}

		}
		void BtnBorrar10Click(object sender, System.EventArgs e)
		{
			try{
			if( dsComps.Tables[0].Rows.Count >= 9)
			{
				dsComps.Tables[0].Rows[9].Delete();
				this.adapComps.Update(dsComps.Tables[0].Select("", "", DataViewRowState.Deleted));
				this.CargarComponentes(this.RecPosition);
				FM_Errores.MostrarAviso("Componente borrado correctamente");
			}
			}catch(Exception ex){
				FM_Errores.MostrarError("BorrarComponente","No se puede borrar el componenete",ex);
			}

		}
		void BtnBorrar11Click(object sender, System.EventArgs e)
		{
			try{
			if( dsComps.Tables[0].Rows.Count >= 10)
			{
				dsComps.Tables[0].Rows[10].Delete();
				this.adapComps.Update(dsComps.Tables[0].Select("", "", DataViewRowState.Deleted));
				this.CargarComponentes(this.RecPosition);
				FM_Errores.MostrarAviso("Componente borrado correctamente");
			}
			}catch(Exception ex){
				FM_Errores.MostrarError("BorrarComponente","No se puede borrar el componenete",ex);
			}

		}
		
		void BtnNuevoClick(object sender, System.EventArgs e)
		{
			try{
			int l; // Nivel para nuevo
			AuthLevel al = new AuthLevel();
			al.setConnectionParameters(this.dbhost ,this.dbport ,this.dbuser ,this.dbpasoteword ,"formulacion");

			l = al.get_level(112); // Modulo 11: Formulas, accion 2:Nuevo
			
			if(	this.currentlevel < l ){
				if( !AlertaLocal.registra_alerta("Error de seguridad al intentar aadir formulas con el nivel de autorizacion " + this.currentlevel.ToString()))
				{
					FM_Errores.MostrarError("Error al registrar alerta de seguridad");
				}

				FM_Errores.MostrarError("Seguridad","Su nivel de autorizacin no le permite aadir datos");
				return;
			}


			object[] row1 = new Object[ds.Tables[0].Columns.Count];
			row1[1] = "Nueva Formula";
			ds.Tables[0].Rows.Add(row1);

  			adap.Update(ds,"Formulas");
  			ds.Clear();
   			adap.Fill(ds,"Formulas");
			
			
			this.RecCount = ds.Tables[0].Rows.Count;
			this.RecPosition = this.RecCount-1;
			
			this.MostrarPosicion();
			this.CargarRegistro(this.RecPosition);
			}catch(Exception ex){
				FM_Errores.MostrarError("Nuevo","No se puede aadir un nuevo registro",ex);
			}
		}
		
		void GuardarModificaciones()
		{
			
			try
    			{
        		int Modificaciones = 0; 
       		
        			Modificaciones = adap.Update(ds,"Formulas");
        			ds.Clear();
        			adap.Fill(ds,"Formulas");
        			this.RecPosition=0;
        			this.RecCount = ds.Tables[0].Rows.Count;
        			this.CargarRegistro (this.RecPosition );
        			this.MostrarPosicion();
        			FM_Errores.MostrarAviso("Actualizacion correcta","Actualizados "+Modificaciones+" registros");
        			
				}catch (Exception ex){
					FM_Errores.MostrarError("Actualizacion","Error actualizando datos",ex);
        	    }
			
		}
		
		
		void BtnGuardarClick(object sender, System.EventArgs e)
		{
			
			int l; // Nivel para guardar
			AuthLevel al = new AuthLevel();
			al.setConnectionParameters(this.dbhost ,this.dbport ,this.dbuser ,this.dbpasoteword ,"formulacion");

			l = al.get_level(113); // Modulo 11: Formulas, accion 3: Modificar
			
			if(	this.currentlevel < l ){
				if( !AlertaLocal.registra_alerta("Error de seguridad al intentar modificar los de formulas con el nivel de autorizacion " + this.currentlevel.ToString()))
				{
					FM_Errores.MostrarError("Error al registrar alerta de seguridad");
				}

				FM_Errores.MostrarError("Seguridad","Su nivel de autorizacin no le permite modificar los datos");
				return;
			}
			
			GuardarRegistro(this.RecPosition);
			GuardarModificaciones();
		}
		
		void GuardarRegistro( int numero){

			try{
			if( numero >=0 && numero < ds.Tables[0].Rows.Count)
			{
				ds.Tables[0].Rows[numero]["FormulaID"] = this.txtFormulaID.Text;
				ds.Tables[0].Rows[numero]["Nombre"] = this.txtNombre.Text;
				ds.Tables[0].Rows[numero]["Prospecto"] = this.txtProspecto.Text;
				ds.Tables[0].Rows[numero]["Observaciones"] = this.txtObservaciones.Text;
			}
			}catch(Exception ex){
				FM_Errores.MostrarError("GuardarRegistro","No se puede guardar el registro",ex);
			}
		}
		
		void BtnPrevClick(object sender, System.EventArgs e)
		{
			if( this.RecPosition > 0)
			this.RecPosition--;
			this.MostrarPosicion();
			this.CargarRegistro(this.RecPosition);
		}
		
		void BtnFirstClick(object sender, System.EventArgs e)
		{
			this.RecPosition = 0;
			this.MostrarPosicion();
			this.CargarRegistro(this.RecPosition);

		}
		
		void BtnNextClick(object sender, System.EventArgs e)
		{
			if( this.RecPosition < this.RecCount-1)
			this.RecPosition++;
			this.MostrarPosicion();
			this.CargarRegistro(this.RecPosition);
		}
		
		void BtnLastClick(object sender, System.EventArgs e)
		{
			this.RecPosition = this.RecCount-1;
			this.MostrarPosicion();
			this.CargarRegistro(this.RecPosition);
		}
		
		
		void Borrado(object sender, System.Data.DataRowChangeEventArgs e)
		{
			DataRow[] pendientes;
			try{
			pendientes = ds.Tables[0].Select("", "", DataViewRowState.Deleted);
			FM_Errores.MostrarAviso("Borrado","Se han borrado " + adap.Update(pendientes).ToString() + " registros");
					ds.Clear();
        			adap.Fill(ds,"Formulas");
        			this.RecPosition=0;
        			this.RecCount = ds.Tables[0].Rows.Count;
        			this.CargarRegistro (this.RecPosition );
        			this.MostrarPosicion();

			}catch(Exception ex){
				FM_Errores.MostrarError("Formulas","No se puede borrar",ex);
			}
		}
		
		
		void BtnBorrarClick(object sender, System.EventArgs e)
		{
		
			int l; // Nivel para borrar
			AuthLevel al = new AuthLevel();
			al.setConnectionParameters(this.dbhost ,this.dbport ,this.dbuser ,this.dbpasoteword ,"formulacion");

			l = al.get_level(111); // Modulo 11: Formulas, accion 3: Borrar
			
			if(	this.currentlevel < l ){
				if( !AlertaLocal.registra_alerta("Error de seguridad al intentar borrar formulas con el nivel de autorizacion " + this.currentlevel.ToString()))
				{
					FM_Errores.MostrarError("Error al registrar alerta de seguridad");
				}

				FM_Errores.MostrarError("Seguridad","Su nivel de autorizacin no le permite borrar datos");
				return;
			}

			if (MessageBox.Show("Esta seguro?", "Confirmacin", MessageBoxButtons.YesNo, MessageBoxIcon.Question) == DialogResult.No)
				return;
			
			try{
			ds.Tables[0].RowDeleted += new System.Data.DataRowChangeEventHandler(Borrado);
			ds.Tables["Formulas"].Rows.RemoveAt( this.RecPosition);
			}catch(Exception ex){
				FM_Errores.MostrarError("Formulas","No se puede borrar.",ex);
			}
			
		}
		
		void BtnImprimirClick(object sender, System.EventArgs e)
		{
			this.ImprimirListado(this.RecPosition,this.RecPosition+1);						
		}
		
		private void ImprimirListado(int from, int dest)
		{
			try{
			Formulacion.Impresiones docMaterial = new Formulacion.Impresiones();
			PrintPreviewDialog prevDialog = new PrintPreviewDialog();
			PrintDialog prdialog = new PrintDialog();
			
			docMaterial.ImprimirCabezera();
			docMaterial.NuevoTexto("Formula Magistral");
			

			
			for(int i=from ; i<dest; ++i)
			{

			docMaterial.NuevaLinea();
			docMaterial.NuevoTexto("Formula ID:" + ds.Tables[0].Rows[i]["FormulaID"].ToString());
			docMaterial.NuevoTexto("Nombre: " + ds.Tables[0].Rows[i]["Nombre"].ToString());
			docMaterial.NuevoTexto("");
			
			docMaterial.NuevoTexto("Prospecto: " + ds.Tables[0].Rows[i]["Prospecto"].ToString());
			docMaterial.NuevoTexto("Observaciones: " + ds.Tables[0].Rows[i]["Observaciones"].ToString());
			
			docMaterial.NuevoTexto("");
			docMaterial.NuevaLinea();
			docMaterial.NuevoTexto("Componentes: ");
			
				if( dsComps.Tables[0].Rows.Count > 11){
					FM_Errores.MostrarError("ImprimirListado","No se puede cargar los componentes porque exceden la capacidad de la aplicacin");
				}else{
					string[] res;
					for(int i2=0; i2< dsComps.Tables[0].Rows.Count; ++i2){
						res = Dispensacion_rutinas.get_componente_details("host="+this.dbhost+";port=" + this.dbport + ";user id="+this.dbuser+";password="+this.dbpasoteword+ ";database=formulacion", Convert.ToInt32(dsComps.Tables[0].Rows[i2]["MateriaID"]));

						docMaterial.NuevaLinea();
						docMaterial.NuevoTexto("Componente " + i2.ToString());
						docMaterial.NuevoTexto("    Nombre: " + res[0]);
						docMaterial.NuevoTexto("    Cantidad: " + dsComps.Tables[0].Rows[i2]["Cantidad"].ToString() + " " + res[1] );
					}
				}
			
			docMaterial.NuevoTexto("");
			docMaterial.NuevaLinea();

			}
			
			prevDialog.Document = docMaterial;
			prdialog.Document = docMaterial;
			
			docMaterial.PrintPage += new PrintPageEventHandler(docMaterial.ImprimirElementos);
			docMaterial.BeginPrint += new PrintEventHandler (docMaterial.Reajustar);
			
			// Esto esta por ser configurable en fichero XML o DB
			// docMaterial.MuestraPrefsPagina();
			
			
			// Esto tambien deberia ser configurable
			prevDialog.Text = "Previsualizacion de la formula magistral";
			prevDialog.ShowDialog();
			
			if (prdialog.ShowDialog()== DialogResult.OK)
			{
				docMaterial.Print();
			}

			
			}catch(Exception ex){
				FM_Errores.MostrarError("Impresion","No se puede imprimir la formula",ex);
			}

		}
		
		
		void BtnAbrirClick(object sender, System.EventArgs e)
		{
			System.Windows.Forms.OpenFileDialog op1 = new OpenFileDialog();
			if ( op1.ShowDialog() == System.Windows.Forms.DialogResult.OK){
				if( op1.FileName != null && op1.FileName.Length > 0)
				this.txtProspecto.Text = op1.FileName;
			}

		}
		
	}
}
